package ocaml.parser;

import java.util.ArrayList;

import beaver.Action;
import beaver.Parser;
import beaver.ParsingTables;
import beaver.Symbol;

/**
 * This class is a LALR parser generated by
 * <a href="http://beaver.sourceforge.net">Beaver</a> v0.9.6.1
 * from the grammar specification "OcamlParser.g".
 */
public class OcamlParser extends Parser {
	static public class Terminals {
		static public final short EOF = 0;
		static public final short LIDENT = 1;
		static public final short SHARP = 2;
		static public final short UIDENT = 3;
		static public final short LPAREN = 4;
		static public final short LET = 5;
		static public final short END = 6;
		static public final short LBRACKET = 7;
		static public final short TYPE = 8;
		static public final short MODULE = 9;
		static public final short RPAREN = 10;
		static public final short EXCEPTION = 11;
		static public final short EXTERNAL = 12;
		static public final short CLASS = 13;
		static public final short OPEN = 14;
		static public final short INCLUDE = 15;
		static public final short SEMISEMI = 16;
		static public final short EQUAL = 17;
		static public final short MINUS = 18;
		static public final short VAL = 19;
		static public final short AND = 20;
		static public final short BACKQUOTE = 21;
		static public final short FALSE = 22;
		static public final short TRUE = 23;
		static public final short LBRACE = 24;
		static public final short STRING = 25;
		static public final short INT = 26;
		static public final short FLOAT = 27;
		static public final short INT32 = 28;
		static public final short INT64 = 29;
		static public final short NATIVEINT = 30;
		static public final short CHAR = 31;
		static public final short BAR = 32;
		static public final short LBRACKETBAR = 33;
		static public final short CONSTRAINT = 34;
		static public final short COLON = 35;
		static public final short RBRACKET = 36;
		static public final short COMMA = 37;
		static public final short MINUSGREATER = 38;
		static public final short METHOD = 39;
		static public final short INHERIT = 40;
		static public final short SEMI = 41;
		static public final short RBRACE = 42;
		static public final short MINUSDOT = 43;
		static public final short LESS = 44;
		static public final short INITIALIZER = 45;
		static public final short COLONGREATER = 46;
		static public final short WITH = 47;
		static public final short GREATER = 48;
		static public final short COLONCOLON = 49;
		static public final short QUESTION = 50;
		static public final short OPTLABEL = 51;
		static public final short AMPERSAND = 52;
		static public final short STAR = 53;
		static public final short UNDERSCORE = 54;
		static public final short BARRBRACKET = 55;
		static public final short PREFIXOP = 56;
		static public final short BEGIN = 57;
		static public final short LBRACELESS = 58;
		static public final short NEW = 59;
		static public final short AS = 60;
		static public final short IN = 61;
		static public final short PLUS = 62;
		static public final short INFIXOP0 = 63;
		static public final short INFIXOP1 = 64;
		static public final short INFIXOP2 = 65;
		static public final short INFIXOP3 = 66;
		static public final short INFIXOP4 = 67;
		static public final short OR = 68;
		static public final short BARBAR = 69;
		static public final short AMPERAMPER = 70;
		static public final short COLONEQUAL = 71;
		static public final short LABEL = 72;
		static public final short GREATERRBRACE = 73;
		static public final short TILDE = 74;
		static public final short DO = 75;
		static public final short DONE = 76;
		static public final short THEN = 77;
		static public final short TO = 78;
		static public final short DOWNTO = 79;
		static public final short ELSE = 80;
		static public final short DOT = 81;
		static public final short OBJECT = 82;
		static public final short QUOTE = 83;
		static public final short FUN = 84;
		static public final short FOR = 85;
		static public final short IF = 86;
		static public final short WHILE = 87;
		static public final short MATCH = 88;
		static public final short TRY = 89;
		static public final short LBRACKETGREATER = 90;
		static public final short FUNCTION = 91;
		static public final short ASSERT = 92;
		static public final short LAZY = 93;
		static public final short LBRACKETLESS = 94;
		static public final short WHEN = 95;
		static public final short FUNCTOR = 96;
		static public final short VIRTUAL = 97;
		static public final short SIG = 98;
		static public final short OF = 99;
		static public final short LESSMINUS = 100;
		static public final short MUTABLE = 101;
		static public final short STRUCT = 102;
		static public final short PRIVATE = 103;
		static public final short REC = 104;
		static public final short DOTDOT = 105;

		static public final String[] NAMES = {
			"EOF",
			"LIDENT",
			"SHARP",
			"UIDENT",
			"LPAREN",
			"LET",
			"END",
			"LBRACKET",
			"TYPE",
			"MODULE",
			"RPAREN",
			"EXCEPTION",
			"EXTERNAL",
			"CLASS",
			"OPEN",
			"INCLUDE",
			"SEMISEMI",
			"EQUAL",
			"MINUS",
			"VAL",
			"AND",
			"BACKQUOTE",
			"FALSE",
			"TRUE",
			"LBRACE",
			"STRING",
			"INT",
			"FLOAT",
			"INT32",
			"INT64",
			"NATIVEINT",
			"CHAR",
			"BAR",
			"LBRACKETBAR",
			"CONSTRAINT",
			"COLON",
			"RBRACKET",
			"COMMA",
			"MINUSGREATER",
			"METHOD",
			"INHERIT",
			"SEMI",
			"RBRACE",
			"MINUSDOT",
			"LESS",
			"INITIALIZER",
			"COLONGREATER",
			"WITH",
			"GREATER",
			"COLONCOLON",
			"QUESTION",
			"OPTLABEL",
			"AMPERSAND",
			"STAR",
			"UNDERSCORE",
			"BARRBRACKET",
			"PREFIXOP",
			"BEGIN",
			"LBRACELESS",
			"NEW",
			"AS",
			"IN",
			"PLUS",
			"INFIXOP0",
			"INFIXOP1",
			"INFIXOP2",
			"INFIXOP3",
			"INFIXOP4",
			"OR",
			"BARBAR",
			"AMPERAMPER",
			"COLONEQUAL",
			"LABEL",
			"GREATERRBRACE",
			"TILDE",
			"DO",
			"DONE",
			"THEN",
			"TO",
			"DOWNTO",
			"ELSE",
			"DOT",
			"OBJECT",
			"QUOTE",
			"FUN",
			"FOR",
			"IF",
			"WHILE",
			"MATCH",
			"TRY",
			"LBRACKETGREATER",
			"FUNCTION",
			"ASSERT",
			"LAZY",
			"LBRACKETLESS",
			"WHEN",
			"FUNCTOR",
			"VIRTUAL",
			"SIG",
			"OF",
			"LESSMINUS",
			"MUTABLE",
			"STRUCT",
			"PRIVATE",
			"REC",
			"DOTDOT",
		};
	}
	static public class AltGoals {
		static public final short interfaces = 106;
		static public final short toplevel_phrase = 107;
		static public final short use_file = 108;
	}

	static final ParsingTables PARSING_TABLES = new ParsingTables(
		"U9pjNGUS5xNop#uULH4EHAKVTxyxfNcW0YB5WeKYvG01wKMQ50jY5nGL1LHKzDaLU##zzzu" +
		"hzjuLUt$lRVxVcIIxsVtj$dx7gIUy$zryaaoIcSbaCYbRVdj2p7lS7xRkW#Zf3vCF#8No0V" +
		"c0Q4Un0j48TGsHhW1LnReFw4U5qroyBMuI$n6xYT$5rSvMJakdjJCLvKr4NMUcNo4dkslaP" +
		"D73lS5v1lWJSd8sk5zHBBguJToDtPFTLcvBjxNRnYrosxhVelR#18wlxPnuKJpEwIEeUTjT" +
		"whxdlkCqJMe9DDkGDf6IHkvpeg7RnRtSFTUzoEtfxYIbyw9xh$kOlzcw3#xdxadkD#v#xe7" +
		"kNQAdky1vo1tWzdFl4EtypSHsef$e2wejrdsm##4tv7xiJltm6wAstReFjlxENDP$iDQ$dJ" +
		"zqtOU8$Pkm$aD9VsSkQeUi#n2n$s6i$p3M$q3Kbg$xaE3$8xJ$bFjRhlkGuFyZIN$fetRYk" +
		"Wy9zX#jxJ$H7x$kGuBzn$0#K1kruzPzIB3$E6t$SVxOTHyIx3#1xLyFjMFMVKYm$oHj$p7#" +
		"dki#9DX$2jk$0MgxhFkGS8xRY$NV3RMTrtsmzPUNiVxJUVzTXjgYwWFnUXNv6ecDd2xE5k8" +
		"TiQruMNH7MPlg0#VCgl69aNJj8wHJ93vpDlCtGDcazG0wLH#8fbNZay#9FULp$cHlYNmE#2" +
		"OK#vCfDY0s0rt7wWFHjMfyydNH0M4FCKo#ZhGbnKutYWs8jg1ofEFEf$Zl1wThbRWUavjM7" +
		"uYELUJSfFf0TAaYPzFg0z6vYfm5rGTYgofojgq#4Dsgo5bKVI3wLf6pJVM1sA6AdAsh3qIV" +
		"AdAsgZuG0wh8sRBwG0ok8kTcrGTYU1KvwrKVY9EhoDcY#i3VgugSpQeF$2bLv6nUVI36L96" +
		"pKVM1c5X5peRL1sAlAd9kL7qWzgiYPuFg0t5W5Jatg3uGYwh8MR$w0DSALUEiMts0QuMgST" +
		"QfFX3BgiXPk$f0d5GrFd#hQeIfLU5ol$2thZuGAwl8MOtFRKNN47U6LvvFlYRwozUSKSv4#" +
		"HhIDpX#as83udH$ahzDzO7uLnKv9rGVY3EgnYThLH$u0wl89ttfpgUu6c10LRYSn$p$#F#1" +
		"Zl#f5kXV5IxdCRbXzO7VhugS6rSV#BjLaRD9zO6$QnKv6rSV#BjKaREm#i3VkOgSrNXdt#y" +
		"RuixmjU1yLUmfNyMEURfy5UaR7Bz9iG5$9##tQht$tzN2NryBpbV4L8Gzn2ZvYdp5tv5YiP" +
		"fY0$uEtd#hSuqGFIsyNUNv4fwQp#IdvaF55g94D14RY7iAtEgSfU9kQyPkNtc#X9xidTMJE" +
		"dAmyuOxN$Hm3v63vM3t2OgJ8ULjsi7k$Uay2jpVtNzJwXm0NBzDw$T9eVq9uHUxnFj5kjK7" +
		"VkygyRN1x6t3LcmZsy2AwKyBagtO1bQiv7C3VoDG6ojkj3RF6w1ZQzQnjMmD7TEV5YJhs1e" +
		"wLlQvmMMWDkzDBrkBvmsY#i3lLIMkwlphMIMkVrSZR5SbhlzM7uXhgi8blUe3SLsL#0PXDW" +
		"$YsJn83i9i7fG6ARDv46PpAey2NhUH#as0wzaiRaYX$GdX5xl4x$1tW7XCF9vIryh$qDa8S" +
		"GTnFMBaE3Pm5oWGnBk8x$BAEIwZs83uGVpAfGUwHudjGTt#xm2CnhzIwbgARqIvtnBOjOXR" +
		"YZKK6v0x##rndTfUz98xovt5BnGd0$RwZvqtGDdTUJFOwnlBdRqHwJo6K$nCgRy1SCEvQJA" +
		"jVoN2RBi4rwbznIIS9IRW5DbNzaLjtpJ0sUHWd4qESWyKh$aRu6pogDVFwo$xUXkcyoX0xr" +
		"vb2My0DpesIwPr6e2cHwJaCLdgpt3dk$zrtvAbibIie3WPlB7UOKPBVmQu5hYd#VLbgVDmE" +
		"e$c78VJ9qaV0Vn0fQMpVGhjlT1eZbq27JDYLtU#Tmpic94Pr6RImBlIEyIovK0n6bhkZ$8D" +
		"qtaKY9wUIodic0dis2A5zaRGdMANGCSfOck45VvCEGNfBnH7mPtexibfe9z$ldy#z3lUdqb" +
		"SudPDjuzAdGU0ZtKdwzAfxa2$llZPdUME5zk0keUtgUU9Exowg1lb3dA7k1NkS7SFTvexmv" +
		"tjpeK$JYbe5j5WKa4BEKbiwNul9m5lId4oM1OSxPL3mnLURxzGJd9kJ#TH85x7I2Fr6a2Ah" +
		"qUwRp8jV6UIytoaR7Vn3i8N$gLoTwI$K9mCbWtFyy#3XlVvbnAN#tuwZmBnDkOqfTiWA1lM" +
		"WWqJQM73tM53ksm0R3X0tEbV9WS0tupYPB1iM41N6#xZ$cN#PSuhpX$fF0gSZM13fB3XWC2" +
		"6$P9fHM#4FdQ9$xtOsl$UBH7t#jy3$uNYPB1iUA1uYFnGp13RWAT7Eey2yR3ucLEcPXkkyE" +
		"gcK5$fVr$GB5BoJK4B$njnjFCV$nlWpIbE1ik6iyKJqF1diRVJ0BmzqdaqvtUY9wKUgBKDD" +
		"tU6fr3NzxznIkqIsTy$dO9J8ViZBQGu6K8DvN0n6nh#nt74mQWPdiwZmDd8wqGf$B2$jk6p" +
		"yCD4Mj48eQ5Tud$dj42eustdV#T$vsr5SJA8RRmXIhutmAlh7I5UeNqGvOUdysYu043I6$Z" +
		"VkRxN4#U1hyN0b5PgGvlQaR9lnQi8iqLN$rka9r2S35u3iGt6Y7N4AbzND1BRYuOetp2THm" +
		"7Mx3gKkcy0DsjsgsHQztJ$M$YXNRO6VhX6h826Qu2tf3WPq4u3yORhEuyvMmRj5Fbhe64gJ" +
		"y2v6QNGS4t0MPn2#oQqQ6QNo7vORVhvXTZt#W5lJN4o53JohtA$yQyIsudsecz10pf5#5Sv" +
		"hs3VI#LHuEpdlKqfzhr#$WB$AiZeuYz8fgLoSKoav0VnfV#3ipzi#0DWPuwJeP5usztKtSn" +
		"jvZPtMuXjCCezCCe$m8RfF0pUQkzzIc737q89ARJt#Z$0XbQ9t0qstCtfv1qZTmDUH74oE1" +
		"szAntXREejyJvn6eYlH0$d2Uzus71DEey2xtll39OmJEuc#dglUASxcpYJKcZl1PqRATlLE" +
		"qNkoXhkAdV5QhDh6h26RPnDnO$#DLW7hy6S#OFeFPdEew2W01gIXD5euI3$Qkzq$sh$e6HQ" +
		"AXS$HSfsyKwJkq33aN8NIYbE1gUZkyZ9E9iw7SNRpkRGj97u5YlNBkungjxjdyOfteQ6964" +
		"OyBxYE#zqiG8sJ6wb0MXws2N#rzw$$A#TJluL$jUSVXq7EdrnNKVnkTEEDFG$SCv1saXyAh" +
		"gZveC47fo#DCQdBsy9dRwSqIWvqBlRtyg$t3yGTLcdBwhtlnP$sB9a7#zssSVf9Fuj#r1AS" +
		"HnmFgIwZlvMpYMaeNU6SoLi#8FuNlZWFps1Owo53tHgEOL8nuljGNsuzuKppnygTaB9AAvd" +
		"3GsrqqtsyJj6fFLo2X0sW6wzP2$8w9KDq12nqnuw3lMkWeveKJHoXZdbecyo3pGCyO5YH#T" +
		"CfEETCsGl$s1$gEFuG$s3KJ8AGTlGK5EvtoaYhQUGigSp0XhsHBernN60XbGtXJMy4HeE5G" +
		"ETFPpZHHzdAVZx972CjV21pfxEEAJZnNz1FHiQrdKk4qUXP1I2qL1JYyK8NIFIjdCRo#qmK" +
		"owMsr5ASJ9WfhphtK6Zx5pgFO3q1F4TP6tdd9BEepblSZP2E#Ezo#LsiFq5eg7thBT1MCyQ" +
		"6jgJ4SwFyFTmwYDqSXwNFIYbE1cWsRdUawpXHjuByCFjd9inoZsSXkay2bo1AsQIq43s43t" +
		"StTnwZkCw4Oez34QKtiCH$ctb1t9RiSBT1HZZQU2Sucz0TocSZPm6RZsqT2Rou7SFJ#THuB" +
		"$dlqyfJb$RuZI9d7kMyo#R0XeQx0YvhJStmj$TkngXbNEIx2wxEyifJWPe#AvtWBS0r$JFk" +
		"ozvpVnttKSS1#Mtf$CeyEgBWR8xN#jrnqxKs7t4RmGDWteUPOt3XjszsX7#Rl9zsStPsFiO" +
		"6EDfu6q4lJhAFJ2omyX#tbEYkzSUDSFIUJJi8OV8Rj2maUm67smlXpYEjtbOpngQLZeY38n" +
		"mTvNloAvECwSLCCRJm5lcBPDloJUzrKvRxncl3#5eiolsbLGU3PU1ioiqx86MbZd5th7UST" +
		"uZOJrhQ5gvYLgAS6$ZlIQtSSgS4haDy6ieJWPeUAVteDD1lkrqThexZhEjTujy6xmzqdaKO" +
		"6OjuxGtGXzd1#ysS3is1JGCMW7DpX7#hPt#ScllLsTtkJNIfocE0zP3nCuOPwmptjaBU#eq" +
		"PxhtcJCBsDuedvt0CTR21pf7EliW7IzMWFfWvn3dS70UWP9H26OzrDJEGharqLcmbNCKmc9" +
		"dYTmAS2d7CO26Y9rJdPNEMSvfpjdEUSv5W0kTYvtBKVFV18wn5ZxGkLR#XdIySptolpetob" +
		"$aJywjA1c5O3JKrCwz24z5f7LndaPurdb9Ta7w6iLnW8PKzxhpblEsiyRvnldD#Q$ZEzAjx" +
		"TP5hPl0CTR21xeDt3f8nxiR8MxePjmjt0vkH#2Z48o6Xhe7Gk#8jCvk7uGTtPrbPzaPzkqS" +
		"1xwpHEa1xa9tkNk2UwgxqZt3$z8ztptRlGJbLoJmq9qbXU5iurxcNabd6$TgvAzrRtAlTsz" +
		"sxmQUTRP1sOC83qMabRiF8ppbFYtBaJv3SHHOGqfVS5zqNtPVSrztFt0$T3zoFt4$TRz4#G" +
		"y9FAIXmaZ3tznVMSFVaF$3A$0QUesyJO1dQrZkjKPe4P6sfTSIeRC73EaM54U1DQIwTdA4r" +
		"yFRnklgxU2LUzkB5TxktY2K3qtW8GqL1Wr1MK4QUiFabi3ty4PxUtfJK6TfoBIp8Mqgmeo8" +
		"j4xUFWW7UOVAJhAJ$mN5KM0DAVtIEz8xobliBVLEz4xoplBE4JTuvu9tLG8FQQWmQEXTw1Q" +
		"p3P7thl2kywxtRl1kHfsj8T7EHlqz27T5f7NqxaEuttj8TaJwECLHO0svpdlCUy9xpdiULo" +
		"WlUQzxRtZlUL#X$5jDju$5GnegZ3JypkCxdDv$P4VdwGB7#wwWlli5wXBkS4hGo1$jzlslv" +
		"0y8tyar$bT8lwOu2dmLG7NVoc$almkAvH$2#lE$ef35GrS12gDHnX$VWsNga3FXAk2hR8bo" +
		"Ho4eKApmEB0DTrGqsNyX3smOyf0D5HRHq9Q2kWGRsXAPVvNS2VcTc6CdXSU1DTn9qIHe6F1" +
		"0mv27D5HOLCETRCuK3UDQx83y3ionWyBJ84N3d3mXfv5kSoRJPadS7ldjcMDxXQT1YeOvUK" +
		"9E8ztcJARDajWR#TxCqLlXQP2YOKwUaDD8jpcJQRCaTa2#0tDqK7WQf6YOaoVaDD9jpcJQB" +
		"8bbo9SnHvd2uy0pfKpH96WOy62cX3mqKnGMdIbbDcVAJ8bhKO9y2NEKA3mDKZJCoHDo6kas" +
		"Pp9jbiHYv8kPerZXQP2YOKwUaDD8jpcJQRCaOWmaZuCSgF0qID4m9q$8QQJRdCcqMHBR8z#" +
		"UETehF0xiX#qLJOA60G$yCEGXFrHOr0$RsvmfVXZNeXtoxPYZdSBZm1gsKpG96WOyq33a8G" +
		"qL5jMmdSsPec5SYosGtu8vjb1u75Z3BHHDWeO13pGCUKX3XKKrtCBcJD4mhiNco6$E79ihF" +
		"0wi8TNr1D6fE7Sq4QVnCuTJ59VXWOOX3sceiAY6c$FJ7e7pswseIzBmjhWMxXgYfw#GGieJ" +
		"OX$tCBUJ#0sQz1HNYTEWpKNU$j1dNlBxD#2vtrtaDlPsTdxq#hfDnStEOQBKcoykTeyHmZb" +
		"GNEBUA9QAwU9oSQ6ta$EpUvn#$uR#pXTdYRF5EU9SSPwuL5mchX1NUjU6p#QyvP2#m7dKVK" +
		"vSPN#557BLLqYtgWnGGxbgutJqJeLev6z5tpnIDSvxcke1vmDDzK3KQWxwutO2xvjKnts3r" +
		"PpLJjDqgw75VG9tweaHkvIivbt2jhw4HX3bi9hVn6zYh4Qoagn6NiFGM1mYvZf5iD1cxdFW" +
		"Ix2QV0#wpoBTlIz1yOHtddUP4Du5tfdUozwBtgSUVD1LP#Jq4G#Vy0ezHb$xcohmheKscqB" +
		"Y8hynZw1vu#fTVrCvd#gIGCud7kSWDGSmugT5lZixN#akUihvHEayWZ6otlyLddDLGQ6yo7" +
		"b3NiJlabqaBtAVe3WAFACeJUqPrT9uUoMCVOSvm3nwF0IzI#PDSDwH3uGz8xdqbM9djVN5O" +
		"gBzIJxW$Y9NGQjLhDKgkGfQhOe3jq1fkbPKsvDdjQBdzK5n6grOok#MLbHxa$WFnYFu$Z2F" +
		"nq#YBhGwFn#ml1or8PN2WvNnVBzXMEetT4w4DQyDEQ73Kzd#eoMUbmzORexQa4hXWLOM9iz" +
		"Z$y6iipX3RphEcMjpeVRSVC2qEMfrockpeLSyc0yD3RUupM$eVGIjGiv0A$T8zsZDTAkMU4" +
		"u#0Et#kMe3Ag7mG2iB2$2U5cUerR7k4cCjBV7iVC2qEMf3AeK7kbXOWFUqECCHh2#4pONQi" +
		"$81q#Qe3QaK7iYti03lQN66MkrkQQKadfaFc3P7RKYby42#XGLuJuipr6gofPMIU4O#ODeS" +
		"jIRrvokSKiKJj1JKGwkGCzJg02RZDLUUuQv17UzNsBjIzYiwHQMid$kwzxCqtcrTYd7ISh$" +
		"sVgHJ5E#smZv51VkL$ai#v#c$EO9nx5V2tg#yQ$LU#wwx1kkTqltTRDrfHSYvrzw6lJOyMw" +
		"c$HkxNV3Pfe00bl$aDl5sTdwszbYs7Ka5n4eXZYTCxFrjtSqvmrnJKqwU41jcQ5snIYLE2Z" +
		"EiEpOleR6BfBfJkHdCwFUXIuItFfNkwvlBxtBepRnxTlKosxcHLvmtdTz73OMwt058jtJKT" +
		"MMOh9TdvjotP#GKr6p1DSNwhEpzLJNFKFIsU4OqWaRxQoPh37mEzlUMaD$wU5o$OcfFUHcw" +
		"QtdvzyLoQvgO5voU$lce1rn7stqNkbhbRyFTJ08b5$dxEPg1T9IxMt9SuNtEA4x7p4z8pBS" +
		"a99#BWT#a24YUmxWhVJnoloanfwY$QHOWfdDFz8dpx#GUOD6ZZLGMSVvNA4KyGynMVgZTf2" +
		"ao8oK3g$4fOoCVN98GzgAz9WFclAE3yAtHDWjohgawLeNIrIbFWrL26VosdQnIduRUmQyKl" +
		"26kOzcK5NATZbF#Yg5MzILFW5Kl6puRUaiOb$ZwS$kpleqklz5zImFcNg1pnoqJ79LTQTMd" +
		"mSYW3VQPKzTdYCnYINqoT$xm2pkkOor$IcWTrgV2I9UDdGsz9un9$NvFgqYlzvnHm$ZagH$" +
		"myqMd#i2uDde$9UCvmXdpH6bNdFwk0yphcSiCVrAN2Sr4PAhMaPTMeElyP1PpNCPSR$g0k5" +
		"PwDob2f9IshHjNvJolWl8wvtF07TQdmJ5I6IYrfMJMgpdzA0UTrpEM6FwXBXQUZCbHgISkg" +
		"KNN#4meuhsCkD$n1NIey5PMXKajQLesgyvzKm7aTSxdX3#fIuOce39LQqh9gL9q$MW7dTSp" +
		"bXZ#eIuKdep9KQadBgb5r$YW5dDSnbnl#e2uLHaTbgDIIbbMZwloH2ZYlOout$45TAeoAob" +
		"2f9IshHjNvUoZWl8wvtF07TQamCYf3fPQqh1fLvuzGm7aTSxdX3#fIOO#e39LQqh9gL9q$N" +
		"07dTSpbXZ#eIuKHKHagjQHbrQWw$t45dDSnbnl#e2uLXaTbgDIIbbMZwlp7571Unrnk#8Ew" +
		"L7WyAaEbbhIi6bNdFwg0yphcSiCVrAN2Or4PAhMaPTMeElyH1PpNCSeR#O#g4tbObmgFHcM" +
		"er986u1CWrpWVkEM4nwzDd7Ve14uKcfzFu3W1vZZZAqgtiVE5ywFp6Qvzz0dSAS89V3EMmY" +
		"Tmjxiuq$c8hpaBdOyJJ#3cbwuYZEFWt49n$2f7$iozP1xH9lQxMH5ASckP7ATpDNIWsCfRe" +
		"4gLBUFNTwespaVNTo6tQSVjAey9HZoWTNwWM1wJgsNYSxT1xY5v370QduSKJxnbFhzdjUm$" +
		"94Hso#xMwNrsZWibw5#bqRsEJkbzTaOvFGFyFMSxLQ#yZ2st1ZoHPn$X7z#7mJKgNMUaNAD" +
		"sSk$tFtBtyVakdVyHgCUwars#kekzgVEHsntNaleQDV4#J4#hwV3kqGDfrwZ#SlLB6tTpVp" +
		"bmGN4SL2daVOBmedYSvfbupsr7yqpLnlbuf09kxXMLqfNM4WtBARRo5c1yk2usFahE4XCY7" +
		"3G#6eTMEwfwfZzAmnAAhRm5Q8$h4jixoeG81xMdSRItYwfd#daQZgBOobk0zhWkiRrv9aGu" +
		"g3sDexq1gfxfb#d$t3VFNmPSK1m7jCTrYUqjCo72GUrf7EqDKlLCVwo6PHHRUGlG7jSbjdU" +
		"i2H4EQa$ZMFUQgtgcFrB3iHHRUGlG7jSbjdUa2H4EQa$ZQEzTLS$qIpKSIR6Ljq3qL7MnEN" +
		"QjuZSXmc59rdgPqkCrBANOobk0zhWkrjvzYj#428SbMRTdIe$JS3p5Lju2jCTrqVQSUehVX" +
		"0Y79LctPqgFqN0SnLRU0hJ7TR7sPYX#4o8SbcJTdYazMiCn55jv2z0UryNQcwFuJOXmM99r" +
		"UwPqiOQZARRo5g0zhekrf#vUB3OXmc59rksPqaKQ5bDivIr0UrmNQq$DfqKcH3WioRezKxf" +
		"GmoAAhRm5Q8$heksvxHM$2H4EIx9kpvGUhc4XnLRU0hJ7TR7sb7qEDo72OKdMxPdIGpKSJh" +
		"6Ljm3jSLsqFQ#fuZSXmc59rksPqaCq74gnbRS0xN5ThBqj5Ry94GvBicxFb1wcuH2AhRm5Q" +
		"8$hOkrjg$XDY71OadLxflG83OTHREKjG7jS5srFVAZuJOXm27bWWDEzV15AS2Rp#Ui8TVvo" +
		"JtIVuFzpzRnuGNpWDtRc#utzndp#Mk1CoF7kIMEc2#xjqJC2ucCi#ZvG#4of4UJpzKl#9n3" +
		"nyvVxjNv$8oRTso$#jCqvnlrA7f0cNHwWfBl5ITBb0UOAI1u0oW9BT#4KqNEdoZpbI3qxOa" +
		"Vmwn5GYYkWHlxEWVNurEkhFQDU4d3vnwv#uyV$M9rw5KVirFknBINfr1lv8fxWB#BDuVz8M" +
		"2$QUf2h2wmk0NonBall6$75SRgqRX9GEIizDlGMCLwN9VXBm1SyWShlBw662k2DkkrqRwoy" +
		"zCfwOwA$h7$I$rxBrDYznkxhblGQk$z3qeCTe4PwZVGQwJNIQwJNIA#HNYEzHlhV93rw3o9" +
		"9Uhvx4DdI$Ng1zF0#WS83la1wtli4yNiGgD4oKkyJh8Lbgd2VO3qOrHhfDTBNUYLeIe50uG" +
		"ahWRfZtpG9D4zy9MWQID#O0e760xv0#iOgJWB34sjzOoCZQoK8#DPY9TWusZfM0YrZVHxL6" +
		"karqjS$wNB$DEbo$rpIvVxgUOstYzmVb0M9qgl#l6Plh11xUwLU5tzlVs$d9uhZG1GKgpzl" +
		"HuHU9gTg5OND4PO4T1bEP#cmjpzBuTaWUgew$WkVFGwEy4SvH5YYsvib#9iY$ZGTPldJ59u" +
		"DgbHRClw#c#6FSF3xRW6telEdkLsHJjTXcZzTuTcWIkFjqVjk5d#4WziBk1KTIcU7xpBwqz" +
		"MlYVmNBQ$evh#OopDGI#yolgZ0sqlXmlhpNxH#h$GYMg1VZhp0DFgTCly5j11yzo2hXHUuX" +
		"HSKq5DQJaMeANA7g5y7eWLLyxnW6lzK5IX6UX35ST1rzFTSriYTYhOCHQ7XO4i6t9hk1Ey3" +
		"$mJ6Jq2w8SLnq7N9FdA22OWB3GUt571Zphm9x6IqT3Bpd0muWUCOmFjFLZGHxrTlB9ziWWr" +
		"oQLZ2BNq8R0NALd3D2i397CT0BgMOEEHIQTvT4WfJ$8eRVT8SwFlg45Tq$ac8JsBy9C0AZc" +
		"E0FfsaQ29zEbjncO2uq738exMyW0$OYOXFv9eJ0ITn70DvDCNSZwFbqK6Vr7iv9vg0kD1mg" +
		"9eGfvnPSVati0MwF7mIV8GtA#UyUfLNN7gZvbKH#tEF4VHcuAkquaAlPvsVvBCOiINoMVci" +
		"$oh5L1e2Q4$nTaJeHPX$YehZ0FjoNLnFxiqf9jZSIhBcLhq#HLOee5uZFenZInhNaJKhae2" +
		"fHK0nKG7d9g9q5yDfrP$ATKbmAl4m7r5CKC2S4nIVvZoLAQcs0jY49D0y4qWNnECLi8JnKl" +
		"$Qq99EjHEvBW4KZ#93F4u1SuvJCXMdJgbs0jSbWE9HV8X7AM3EKKgcujGfrOxdkWHGF8eFy" +
		"KW5p3bIwb#fMDAfTXpN9O3YKNo8nofWph5I$#x4aawrexWk0HIFuaCyHW5pZf7wJGbBEjME" +
		"vBe4K3oA3$6U2fXpJoLJSUgKQiToNG8e7iKdzpGx8C#25vLCnQbIgYDAGnS5nQFua3TxdGX" +
		"sIX7kgwgUALz80iMZ#40tMW5hCJhODmFfL4UKXYuAYaVnoT71YaPhK87KlvaAfTEAnd9Jpv" +
		"1ojBk8gAEIU4NZFxMYqJxkRYB$1Sf4ITvkj3QgCwHR7fVbZJUIlCdkAyvFNY5ahVGc9ikIA" +
		"zqDp6aqMvPSQMJ9bN8bPA67RdUKflRGsz6RHhAyjd5PTW#Tzo3hBPBbV90iotc7PRsZJib6" +
		"5htf7fT5rY9PShyqoylzGbd#XWfuz3bcFjN7$UH#E45jA4y9wQ8WJo4UOw#mX$w6RArJ0fc" +
		"dA4hQuL2QyvVktBfZzv8v2unMbAFVeHjvQRtqTaGlUoMyiJMFtjYIEDFBMTpBMN8MTinPsK" +
		"0KSbQWKz1BGTTbXr2jgtv9ET3GyHV5c4$alkepRwDzvd$6tyBWlyYtCFYzjl2wBErR686aJ" +
		"mI$rwQ$jK6IUbgIXZeZpOwRBCd$993qgPOKwhHKJ5Tlo3b3XFMN#8tP2$rFvOKyvXTIId4C" +
		"hZLrI0c$riG1C5L89o#Xe32Dn#5kK7ATuyYxGN6tYGDWAd5B8EC22WhJU0oOajDi7tBkPn$" +
		"YMkw7eh$OFLHUh31viOgZm9IKxcF6byz5wbg5lgirJr6nJEAOgqP5Nkn$xdyUznJKgc$FWG" +
		"uoz3LFulysqz$wGlMHwWjXmI1k9wQ8lk9GhfkM$8KmGLyLmyhY5rk$12lcV3PiIh6ei5eKA" +
		"XRQTvpTkAo3gKi4hWs#EaA$2saGQBp0Kz$DNAXAGPthEoiBpMobkoZkxH7$DMD0SdBTyVpA" +
		"2xxKcJnRWzhKsUf$5QuRwdvE#1UhITSarvT7Od$1$yxDQZMbfffQ5VOl77EiaTOl7FLVWaV" +
		"XZ$z7ZlbVnZayokrlUFH$pmdmG4he3PlAEUw6YVzpHw0c#7PWGUsi6Jd7U8ES8#S4LacOaL" +
		"w9NuQME12OD0gwj1Gf1mAJHa6LilQRKm3NvWICPu4grRqjzGhDoSRleSFcVWz06SLo9UC6Y" +
		"BS7qMWBAhvImfZoB0eetHxOMQWvAm4svtWOQeTn3uSfF1jKARTmBmNclLVZEZPWg7GFXeaR" +
		"0iynBMtEqdPCRqaUYdxmxoVaeV9GlupYEFWjLCoIMm26SQn1yQlLaUcAqrPALIfu1p1ZOLy" +
		"PCqLR2apVLkDPe4gZkvGp9Dobg4xIQUKGefE7o4EmInsI3KH1SUfkHnG7Es$9Wvd#OE3tKH" +
		"m7eg8uLGvH74I1wG#I1paFKXm7fZWeJGhLeZ$yVs#9pc$hF9dBEl5VQCV$$FOvxxwqfxEf9" +
		"QEd9SDwcvzau6oQBECNTmEVlc7pblyBfHoFfpY02tKftRSa$48J1q1yV78YEgb#AVapy9yr" +
		"zhEAvJAA0$Z5rEavkopujSOokOnwGdM1DAQZdW3B$KsgdnFjQhxjmR$tfIktTBigIKbZuo$" +
		"GAV#sDwTTbzio$EKfOtD4BXanFVO9zD1tfBrwB6lUMiY8#va#dIdBfifOdbD6yFSdzAYHyH" +
		"VB2CyDkMMujuRNjscdoF392BMG#0kaAiscjUsflua2ebPn$Czd6OOk2hgsKdg0CczV#9v9L" +
		"LRSdx3YmfBEeVvFb78ydc83ycPT2Xc4ovjDR83gvCtEDefEdivz$n7uZnhxKSNoT8e3#CdK" +
		"gJzvUh3YdYvFvnNtHoeDPMXh$9XdnVqnVJyK#fVVpa$U6VIRRqy$x$5Erpeyuo#bu2sHpyX" +
		"dA6zY0u9$KUwj4DQloiL5uWBpk$9Wx9VQMY0NqKBeRmSMODSLbpXqf$0P#d89#FubpaGmVq" +
		"bVBe44N$Nb3eLdW$EUggElGWYNQUy3r16jSINxaVWO5E#8QTdUvgpsZNxqDB29$0oQSI2WV" +
		"1oOjaAdGZmdDXRqnO3RnH2VhoFzs$tRmNbxDa37snMD#aOWQE$twNff48y4UFZR7NgFuolP" +
		"iob0nzlziu6$Jt4Sv6ok4pmcTuF#RfPyjtytQX2BkoWsOEhG7lZKcCZPShQuHBVAOoBoViz" +
		"HOWQhG61I6zGfXUh24qlqt49SAatwKzJml2R#Ac2hk6oLlmeygrH92AQElmqYl8t9mevvPj" +
		"e3DJsO0rSepZlgEiM#Uc4lK5SlsVzZv4dKR4k1PMrBQHWRG5LFdTAVjHA1hZjgkZD7Tx#x7" +
		"Hjmw3VpN8g$yJ7kRgYXq0DnDyxhs81pj2bbRkjFxiirNIcmlbqvHIptfJW0kZD2TNgk49#Q" +
		"At9VecIUxdptH7zBaUTAO$cfE1P1o4y9A1y7GVTGAb3NpPuhyc4n187aFmpubECOK9tZMTx" +
		"GLIDghdogSpnN$7F4GlySXVddo8SfZeEgy#dxtlorR$zSXMU3gPEFgm29Zoiy6tJfOqZfBR" +
		"rpvMCApmPLYlXH7HwNZoey6tJf8qWVORv759uDgXJnGpeyAXzIU3ReqWUHFiXtH1zKU3QeK" +
		"lGdeu9yoCyeF1jqQGbI#fyq3$eb2iy6LSgZzoK5FoE$920y2xv0wHUK4lWbAet0vwZzN7w1" +
		"VUjp#JceFu#3Vmyuxw4w$nx$7XMZrNj282wKVOAK0yCNEhNXOzH#J2d3vpgruIFKViGf0DG" +
		"VnG4huSS87zdheFp4NWszYvZpGnCOFjQf1Nfkc$GZEW$vhN6AU1CnUNPhlxNya683uImgsA" +
		"YW8U8D2jIJdTjKeDY$3JotgP8GnFro7rNALBTYDRnLOVwjg46Csbj340#gEkX5x#$SG47k0" +
		"yeR50wubMCDl6wgD7lTl5Wywb$CV1S3js83tdHmSsd2kdaHQYvYZelyY#pOW3VFbAfrKyuB" +
		"xUHVWffBcECI$n8vZsA56z1KbnW#kJTX2lTlGSqjp76BVulScsA56z1KjoW#n0i8KxX$C$f" +
		"zCtFSxDyi5r2iS0EAYbB9wvyyZJ25#pU1#oRckCc$IPv6iS8DA2fAYKzxqMa1$YZnv3fFHl" +
		"#SwtHwK#nUqmt9N1v$Szu#XLQ#hOADlHKId0NDz2ZTJi6vfg05dxbEfhYWYNtYKbIKIlEU4" +
		"p1vidU2VoTgxcIUEnLkOWFCgrFqxshENwy2nKZlufXn0q6Tql0w5IXMEE1wZZM4TOpTg491" +
		"O$z6XGEkurY3el9ljAqc5$4Jp6VvFjeY$qQvA04MKgmji9120Xn1iQQXhvuSaG27Kwnf3gU" +
		"G08THx3x0DFHkps7Pe4hvnD5NgEzswDEvdAO2nGf7t8LY0q7Tp6mVuJ$rvizK3ZXnoAb8Xt" +
		"0iA3QWg5IgszvB1OeLZdWGnGRenC7fGlztZCJlF1w$Azp40Vo6$6zS#fl6THp07yZ$mQL$Q" +
		"5p70T1tnd$bqbyr$Yia$ng2V08QFU7$Yftm2OKZznl50Ro1qZUuxWsDl#7$GR41xUEtHwxW" +
		"VhNk5aV#Fm3FHVtSfA0L9teS$GO5RVGuydUW7VK5RFCrDlLDl3CLa2HVNsNmqvyxwUcFty3" +
		"PDV292cTmC3GOHtxwCyGhSZwsQ8IYWSJWMI3BfsU0Puhm2M65EZbwRS3Hozc9Juv3dDl4mh" +
		"1jvJTA0jFGtn0bXzhspwIsWOzMie3nFgfEeN85NR4PpOZ6Q2zNA1fgMomCA9vJkiiLfaIk0" +
		"1xmHDR5Yd0ib6R#QI9uwkwjL3xlVOvIr6ZTAqAAi3UerThxfoaWpOWF7gttWB1$#cy1bVXl" +
		"K$#K$uW5$jliDmj3Zx9zoN$ReRNvRGslArpRzdL54OeFSKLBD0e2$BMG6bTmhycXjYpAAOp" +
		"BNYDvY5zpFa3y4AwwWNlT#NkH3oa9LjklcJpHigOFAU3lHHBsJgJj81T##TF2tY5vY1MyfN" +
		"1TzvQYiDf#n#9xYwGWVilvH5C2zn#sgAsSeeXX3vCyn0hULBYkUpEhtmzRV6#ofcygKFI0D" +
		"ongAwSeOjWR90#nWjKArtMh5KKuPu4F3lXMiwQh5IXwVtLa7LhDkzk#l0wj3beqM0L9aSZ9" +
		"rUJbSZNm8HmBYWqWHxl5BOg9S3bJplHNKso0l9nIr3tDWTRwfv4kv9Zn05v6dl#dWNnPuIO" +
		"Eu4dad$JeQkv9XPiuWAUGVufBdzBuKv3yb0MutfOlSTrB6jTn0FHM7h$n9rzKk8aDw1w$e0" +
		"B52fSlu1hm1GkkGUartgiKAzp40Lo5$5LSUfN6THp0bSXVoQLNQlnAfod51hGsLuRU8Azm1" +
		"iihkFGAIiCuWCkHlvnBBzUuZWregPVhdVzv2kmDpmCVmh6WE02SvkJLpWgA5MvY0seLH1gU" +
		"K1RedKsTaE8dbtnvaRQUgtiYGhq9m$gxdJbFvHKYU4CcCQ$u1aNQ2$KS5D5q0VBJ0lq5vqK" +
		"aBtG#b5LXtJErzLIQ6ZggcHPg9ezFwZ$jmF9uULmWQu7ceFQXYJnE7g$f5e3kUAwXqnjXGp" +
		"HVXLm2kkEOW#gEqp9efYw9wQxQrJkPN6Bw20bBT9y70OlPJHuRs4D4xI3DAORQFKctgz#JO" +
		"ZvrBZr97WjSdoIOX$hQHT4p7vz4G7SIpgzi1s363YAmhVrt8dE7uoYiSKmR#$0lDqM52D#e" +
		"WZPyNWf6sDzV0TViZxeXaL#aA3sF3KQKsc9U$aLA0$jEDcdXpTOdoFt36fQkokXzhi4AI4z" +
		"VxH4BdNkudivpWnImneESktNf$lvAVtS5dDjToVDnAlBLUoY3Gmkmz6cgp5$ft2LFP7ahDP" +
		"3ybTpIIjJiRl6HTEBRNUabrIyrAlp1yaJ2KKf#GTB2aO8SPMrkm$f$S#3JEQJvvx7b5N9wQ" +
		"6tWG#Hqn8CeDi0#Jcbi7alzcwBeI4bSKQ9cWSONoXkvv4OBJb1KHCSoAiWVjRJ8FFRFK23f" +
		"VvtH$vrRZXs6xWNTQk80bbC#pJjHQwv2bylb$Xa1VWj9PwkT8UdUoIqcDi1qjrZsobgX57$" +
		"mRE2CC7MS#DeHMR47MIjsXUNPR4rtMtlK5RTSdAO7QcpgGP7zOW5gzUoMYu6RbMInjlOW4U" +
		"u0MNhOP$x4$K9nfwmaygZOI9newkHHN79Yn1#3jkLHff$oA8tJN3XAs7k5a3S5DKS27o9le" +
		"XAA3I276aVztkj4OVyf$pmos2kE1CnGDIWLm1VA6LH2SG1tg3pp4dw7YGEuZlBEAgOW$3eJ" +
		"1t2zAKLA#FKc3k1sKugKyDjDRC2vGjucWtTCvMqKJ6n0rqHyAE#TCKtjEEvsEQdj$GJsT#d" +
		"N0aDIwRFyrUsRuA#gB$TRNd0$vKsiGDJXqJBlXERtLv5JCs7VAI39xhA0Uu7o3EMTVATWWR" +
		"fQnnL#JZlQjUvvrdNs7Lcr5#ValJHdxLKvQw$9MNjTU7ylzpcpylTIlM8XSfppai#PKQsUj" +
		"ELRx#$o#SRh4F0kq7lDGZCkxWvgNFAVcKMEqqkw$pelH$lYZKhgItnM1EKYqgBbxIBNcJb#" +
		"rjOhQwLE$Mf4nkISaH5DlKdwj92lnIGV25PMRwRTWxNGTE$KDh96qDjN9AxbbTBK$5LumUz" +
		"hAxTAHBt3#oPI6xktvVqxlpRotf11tbk0G2KK6z1KmVM0xdzQlajAtlnrYVPVTCawTm#9r8" +
		"lmt6td9P#TlTcK9rpUWtWGnGR8evagwwfGdRl3lBnBvUdS3HnvAg4uW3kvHbc9y3jD7C0Dg" +
		"iQRWvJm6qniW7blIFXzrZaq5Wdb5wIKNvXIVajA#MqfvNUcbD#JKlveIlbdAUK$SdcmgsLJ" +
		"U0SRBwJLKxwdTpNXt2BVWoKJ$ljouAdl6IoazThOj5wj99gelFmKERN$mVifr1vyq3w1wlT" +
		"awtX#T3tmsaJczTT4K#0bynRKefOZpydku$Aw$9piFjZdFXChq5QxJy$AS1Nxi$bmbaPdTS" +
		"eihbHUpKgJpzwNrZOlT3wYk$shd12F$5P7c95ro$ZPYCAnmuSOwHxdiVlY1FUmjOzq2t$Va" +
		"y27lhlR1$MxakxCjv0qy7btC36b51imN7upE$QREMzHRA20lx3dy7Lazl$P$hErtjP$X#Ia" +
		"qScsdRAlyweP7UVT07iVyt9jP7mOS7uQO9#lfOml0yvl0#pxjPFXUe6drG#mKbk6oF6d$Qq" +
		"n#viZNE690b5BrCPrIrrHJzGN6uWDHGEnaMWe6eb2qLWqmVcZgTX4R2es4yrm4caXMefMEF" +
		"Mq4KMYhIWM9I8ZIaMPs5ni8Tg9zgA3w2WwYIr5kUYCFNqhiRNOHdGLtKHtiQteWRdMK$GIl" +
		"KKViRtOGUmeTkAPjulOLUmc#ed#Oe0OA7R7J1sCkJ8Kyt##60xT7DRj44itHqo4vasGJbsF" +
		"#Z4jgn#JqOz2w3QjclfniRY4#t6vrO#Ab7uuw8SNwOSZXg5aXDX3Z1IZn6X1x$kF5UFu7Sn" +
		"rVmpcYdbY7x6ls4$iZ$4u0AleWU8WSJ36OwBMVltm9RiVZjMFEcBYUgV$P4j$PptKtxR$vF" +
		"LGVzl#CzP3$V#N$5#iX$h$Bzd$iVLG$$yb#r#$7kh$lsJ$uUkX$l5ptFgc$p$fFsTNKNz77" +
		"CiQtWNi7c1ZgbNhWYfgtOwlVKh495pxJ874wjMwghvIdJewLTPnV#ZOJkjOmZfsZkXO9lQg" +
		"rfxChN9Fba77DyIRh6CPwtZoFzgJvzS3lxbbFT2nwNgWuxprGCTZrmCTAzO37RtrGCVvwu6" +
		"EwuCTruVrSNsOrvtN0nsNhWSwhWzsN1zqB5aFT5mVvlNwi3v#j1xeU4wDZZNN2kkGZaNhWO" +
		"xhm$fOinV#zNU5vg$rNQ4Jn8cieteNfI2YuwfglYjKVpsmzlhW4Uk37MjqhD6nHiSQ7Vzf7" +
		"TTknzm$puvP$nzy8dHsbPy8rMSTx$f7UsBVbJtaBtbgVgWuJ1mkZX0BgxadjrazgV$$iYVh" +
		"$dhpJpr$hhEEMd5zq77T7#aQ3V#yXjUlyneMhlCQshEvsJ#i8RsTbFpUa0lfSz5MBt43jrK" +
		"OQKj0GnSQpaWzQvqk$iNQh83qWh$j7REculvK$Ly3BUcVf9tHluArQPn3c$beH$tkfy3Qwu" +
		"jmdiittlCnigHDVsWJSYQFzt1GDSrQlIkWut0UXTfeALt7y6n2Mj3Pv0ln9NHSLWaTpsKTB" +
		"wY4Zjc$p24TwqF7QyLrbXyaw$YSfILfH5gsXuvFvzNnAsXfxaYk2BHCrh4WqOwaOs4bx5W2" +
		"RmgrB1MpMCk$seutGCSVitIS1nqTw9NF7xF7clGg0cy#7JjhVwJrHyt33rDF4#IFIsBhpqd" +
		"Gy46SVad3qogbuIpzfca1qYBKvDFmR3tImw3XY3mZtHuQzevfU1SqlETFsF3zl1fEoxBXes" +
		"jjmxkrXfMpuS$wQaDfU4XU3UUkXGspPxJomnNGe$8sB18NQWrfbBsy6fwJPKEd2dxumLhOi" +
		"4ZSkLOQza#mOTgT2FB3#Z4DrRfzGjurCTImFlGY3SkXLn7gyuzoISo6zLDjc3JAYtYK7TQm" +
		"88U6ZfYivK#3V4SivLmHgFDfI2MX3RlnUQ0qHSF7eE6bCGtRGyEYIgpPmw3L2AsZopeM8FT" +
		"NhzdbANxeQ0rp#U5ywBW$TAm0s2U8lrR3aZ#XuLnGxGEhgHFQ0Qn9$Kff#9obOH5JDaMSh6" +
		"5dQ9Y9QRWKBNwdDQoVqm#dMQT11#1LSfHFjZGC9QIV7f9iE5#lXxbiU2pqE4uS3nbFGhlsx" +
		"95ampfvDTmCip6Sovz3WzMfSvaq$3IcuVcMXhbM6wFXyC1#Qb#kl8R3U9GTQEZb7ELZSsWu" +
		"ln8QqZS#AQNp48tobfNObsqRbaB3z3qbQJrK6WwlX8QRQGthQmsBMCFyAtP$M3kqONtU8NB" +
		"PCAvX2MjuPoKqBDSQBkAKrjt7qUAIl1gIJFDRbmfOP7##1apMy6HeM1ZJS3MVikVdtLFg1p" +
		"eIJJYN2$9gMA5j#3pRi0AbRauRnZKa6rPe3R$FeU6tWOQaZGCUhv8dXw$5ck0DOTBm7RIII" +
		"yEvCGtdyYZlMubHNgP7#Ob0pxbeyUIy6Yu1dT7G4PyXhGjPoHhU3WrdnZIycpLSKGaDwsiD" +
		"v#gPyZ2FSaMbJmvgBYz2lXpj9MlOFK53mRlUEQnXxHmQdWmjQ7RGxjSEBRNZLRi8BURJi3u" +
		"WrB0Gi0AsIjRmCcZOBwPX8S#i5rZ3rt9gM9zvCk8PyInqAcHRLEPAYkf23UVoFOmq3RidN4" +
		"a97kKNyjgGzBg6L#dwh4KXswCows6s3Sl5YoaQNWCD9oTe#AW#EUJISAx#pwydO#ru12tKv" +
		"bsoCdFPiMPA7SId0Zv9qR1#mbn#4XgMeGtIyDIS6f8jw7$672jkHDiEg6j3mv9AN0NC3MnO" +
		"0gfJKLwUek5SQ5WMqx2ChmBAycfO6zfzWwjp1tj22IXFPgmo6bveNQSGxuNCcNw2TM8QqXv" +
		"Keg#NSvrjRkHTf12qZ$DkyWImOw6XoAiXtGia3Hi9#h#0ZJXSaQ9XOSAr7br9NQ5NcwjoQB" +
		"YFMCNZN23QuDJR7dnB4IepKvQYbZJi3bW4#aNiBSaQba73yfY6vq33gr2QpuRxevn6MkdM7" +
		"X9e$oo2vlaqt1sKfE7Rq70WfEoENkwLek5IlX#QRSEbVBUMsi$jX##Az$Wwj3$m$L6pJwLi" +
		"w8Yt0Zzy2#DLcwsOhE6Yb56#HbyllvJpR5DV$0QA#anTNy#Oojmj9ahp1XlXbq7cXIaQxfz" +
		"mjYdaqzTIrh1zJZ$qnAsGkuXjS3tAcuaRAhKUtgdza9vItSfNsRJcfDjmKKn3Z#VohQoXbq" +
		"D33#iqpTv2thbePXTYnEZgCf#6Y$HLG7sUAHc4OrE$CoMWeKZOK#YFD1GvD5H$MB6bzIUA4" +
		"F9eo7JG475tYpDHGvJtHuXeYBpB7D0GSQg6Cl6lHiCQ3MiqhD6mHiCQ3MiqhD4m#Ma5QXqA" +
		"vds7gcX8zrMGqXtcvDFNfLaQEfg#5j8wOXwVfE#05lD5FvJsO$r8dyItGy3J5jg5pzDU5PF" +
		"5wwpVbgYRmQV3CyLPV3eyKXnbthzXdPFqcsJ9cWuQUZOt35fONo55wLfyXPHRIdsp1NNQja" +
		"n7jgLtAXpObkIgDrje3EZD5j0nLI#wgnEn6iO0BVSJJui1oalOQhrm1awtsaGnB$2c#IoBh" +
		"5Q7RTsPycfKkSQyjKIoalrEjUAmhISXFmLMAqgrsjNQQbsKrL1dMGsv75PZtOCnOZeQemx1" +
		"M53hTH3gmHuqWaRt6R18xTInQC9ZCLdFWM6GOtztjbZhFfzdG3SU8$lztxt5R34dlp#mjgb" +
		"lEd7FQAxHUC$abaf5F#RffCO36Fd3RVJV2woUzTBpkbVO5jFsGri3$ZAjb8z0AvIeldSA$0" +
		"TQSPgarIIhhUb$jLQwVTPAuvre10DRGJAmITQRWTEnFcJx3#pyzsfbsuhyXsTTg9NjJPC3s" +
		"hzKAxqsnxHIrcAjBcNPQLejqZntL5uhyV6VjrMmGgLePQnLlIEOMoiP$DLezSzfnUiehQAP" +
		"PAr4vznQwJsm7$GP4DKdUx$Y$JPvPvbAEmjeUBUb7PnFMXtqAGfjaYRXASe#eN1Pudwhwx3" +
		"RSZeCmTwl9bbxxVGSkjDJi5mdb4lZUosj5z1RlK7WQWlT0SauMrbhloflB9RdEVkycgrxS4" +
		"u8lQ1R5Ky9JsNfta6VJGBTwQnWdmkfdakXEooNG$SScelSkYlvLT0zOdLzoecTQPLaw9ugc" +
		"MaoLRDwPJHNyyQSJutLBM#PJdfBTMAqJ#DvvRBUNV9gJYTbrK9zQVtbFekppKCT9w7lKrZp" +
		"ZfhRdg7ToDCjoSdlcXXP7KDjr7lgaaxpLRWou7GuNTSWLLS6Oq19$PsWrZW#SqLzczOukZB" +
		"OHWoeZ1tuRVk9sIsBMGXsoudN996MzJK9h#dMDKbbM#Pdy#srDAjbnhhnivB6FDvPVLRMHf" +
		"yRLwtF64zjxNZBsjfzZBNvZQeSraRzshMSfy$1B4djCrdxx#WppRtAzRcg7fRUPrttb$Uvf" +
		"kMQbcjQhccvfkMQbl$tMpPNiNzLo#O4Y5YT87fbNPjquJDlq6VLBkXoNJjCPChm7hm#WUD4" +
		"tfbEv5AVmA7XjlgQysXnJCfx7goFpFNaenRVHqYujfGfJpwunZpvUC3emwcvwkkLtfwKuRE" +
		"WhEixRa$As9CMkhxJxMawwlzoQi6CUD2oUbkkIQwMkOMhg3LkOGoFNX5Qo6wvIzXJg#LUKY" +
		"Qq$78E6y#t#gpli00RawFFz2KNO#CYiLAthBsH$RjNzDc7fPFoiLpN6MFWtzIUEi#satoL9" +
		"pfmBluqQwBrY#qa7vjljMpVbSntPw1#VXyH5oBGhxJ9HfVp$QpI57kbZbHbV39vV7Bwf3K#" +
		"g5kvTdEWfhsQzlviUy4TsiJsk2PhFjIqLzDUJNirxTMqbxyzd2BD#Iju3qHBQ2AjynS$Kw8" +
		"p2fspBXVq9Ghpv8TafTzfL#NMoGrdi2ADHTviaU4p9GVN4rewq#MwYeW$3#kWpbznwU7fBj" +
		"2Ze19lYGo3lHAae$Vc6GJrtj8T63ztgehkCdY#4T6SxaC7ppVCgJUtR7ElNkOvzJAUwzHhV" +
		"H5FIkkBU7arXo#6pqBiyt9bdlsSOddB6KhptFuYvL$jBzKb$S$uopyjlSRkDNPVjonJO$V$" +
		"HRjRkq6Dz1hfDT9hfDT8hv5U8xr6Uetq6karqckarqYlaLuZlKPwZVJ$QUdvdzSaIy$rlAR" +
		"gkilWNHzWBhyfHy$9kkLx7qnA##r0MOLdWP9$wLzzpnxpjoV$ilVT$anxzBxRshPd$NwdL$" +
		"QlYSJBQ$Fx7N6JjDwXr1AwH7#lHByEH6$edItzJbdkxnx4MY0vuLkQ4tKBvjU1#lrGbjChj" +
		"AJaDoF5rRajoLyRZ8sSc5X9ImfOCcofrz$Z8#BUohMqzjxFVfRL4i$h9ZbRAWwib$MhsDHd" +
		"xhsohHSPfx#fJs5BVtsV4beoNa#$WQsZtYQDF0ckrBoIqZp9jcRKbk8y6VvgIS3hQRKe27i" +
		"auxyVrVyBHkPwGxYIzbLMOVlspjlhytYkLxhNKffU8owB$VgAUosbzIvuORuT4RqkuLvdoo" +
		"esilHtBaZMHFGc$Ps2L5cwxr6z9kRgOusi6bd$hsN5Vp#HBGip6$CnrrbN$TwsB4jMV6RpU" +
		"qvfCrkj4b8czJ11LkLNYSBitwQ4FUHVcYfPfIbwTGbbXVRYCqrCrbgkXDc$c8dtCVzLXh5N" +
		"x9VVl4EezwjOabI$qCzXhQ0dPP5U3Wzqurz#KmyH9iYSroZeOLluGzeRMrM#Hh7UIoWEVcE" +
		"apmLiT$goJ7akhvSoV1jDVGj3v#nVsfjzCSVRQ5mVVwzjdf74EwwM5DbnKxwU5fSKwcI#8e" +
		"RSUTBwI$t6REwlhedGheP2Hiud$DiZzKiGzSqbDLQTSid4EKTnbFzLCgKCPARvKEmBCD1YS" +
		"ULaGfuPt$dA2eXNyIX5P89MVMEWKvAdW5QDIY#cDTSykR$9SBNwGbWmXcQEDUOrF7qTQofb" +
		"#BkoSEIoJetTk7yT4zQLRhf5SvhBDNUxyYp9cl$CCKRCv5JFVxIOwyGSp5RkN#9tCT9bcDc" +
		"gMcJAnDaQrEPwTpIYIKIFg8uvnY3Vkcd9p7gBAXY7n9hgQbL6hdHpj1hymZ7kgL7xyUfcMi" +
		"tbKQL6ttmhBdj3RV50oZhP9Bp#If#HCdgbcEGDCuExEWNvxkfKdf9RKojRUUMeUSKi2DQWI" +
		"4kYWdcRH7ZBPNHNLAU52hrUgVy#W3KmL#kGM$LULOJKClkNgqqudigzQXRecDIhd9PMAtWo" +
		"9Tqj06KjfgBwyjWANnneInR9$sl7#Sf#BC$UfzTMZltVsi#pTwcu7EnIbPGZPLmETgc$H4v" +
		"bzKcJmdFD$0Q4vEJJ9d7ri5QkjTYFQCoi5IZsDd$gVYImgf4NdcADvHd99oDQWP9yd6tNnA" +
		"mlPivYjiLFND4vspi#PxFk$fFSJlQwLPcJEilDtkUdwbPKJRTAtDz969lWDp7glbekkqRF2" +
		"hsgCZPHFVYEjEgBkIDzdfPLQHbnFpEdCvdxp79rBXcMj2hhKIFZhvOHdXloZ6sfTNsRSeeC" +
		"dunG2uddXYhDfdN7MbMLyS#kkEQwyPzVSTFtGsl5NSHQBTPjBz6fq6UNWlGJ56jrlfJMCnD" +
		"zHqDASqyVMDV8MQDNL0lZtU8Xzkx5hBNoxWgSr8S7KXBl7iZytsml2iw4fU8dJadFtmCB5z" +
		"EtjHEyhHUTNHbJ5ewU2ejIlhRQCJWdnvwlA1r5IJuTDRTwqZLSZs8nNosCqNLq9QjEHBtq$" +
		"woQaIYrjlP46fFeILLz#QGuwLknx7tbUaneLEDFi$Dzpp7$ELtflh4zQbcULPBlVm58keyM" +
		"xLNlj5C#peLyFj3V1Z6dPm6xkoo9kBiawc7kwNJDqcAgkNg9#b#MXDJdOj7s4rUJKq9kh4I" +
		"9tD0ZbJjSLSGP4Ts9Fj3UbX1RbsX#gFyjhEUAMPlLrHlxobGrFw9pXNJBFLTWRymLTVfRcx" +
		"aINIbbU7xKSqNdnkWHdc39Aw$ibLpoIXBC3#FXvPM#4izBMIDLZPVCToz2hntQiv96LFqFs" +
		"urpoL0KaR7kdR3#H5VytdcrIQJuyzfW$IwHyRiI2MrfppThZNMrPTrzACdcCFCMCKuHuJZa" +
		"MbV3tKNFiwcvTvVOTxMIxbCKL##wcOixkcw6Nn2BSwkUnbTykwTwhJLdjlMAswpp6kDld#K" +
		"wJqR$xFDavFntKZAN#gy9QLpvsXBdSr#3iolxryDeA$J7qohJL$6GUTA3lkQySnZuvYy9Cw" +
		"OuBrVIVfDo7hFfnQ$vw2Es5jPzDArLrYbHMAsadQ7$KXfnNouQtOkaUpn9DckQVjfBy9EEb" +
		"dT4dkNc6glKjeT7D1#ZsvwGH1jROVAUWAj64Tit8hjJBefq6RhtKQ$gRNbLzlsyo7Lai0Cr" +
		"nLoqtWvLvxJmhfrDAuClmKVMW6v9zL8zuwVt7BlnzospzUbeNKF6tWUmwyL5Thsu4kCOjjq" +
		"na30yV6j2yYcJsvwWdZo9OQOjCODZTGgjpLTinXAW2NhNHCkWjYS455TA$VP8$2u0ytIAZ4" +
		"L7QopK6RgsUNAgneAluvReUQKeEbeKuJiWnKRxu5gUDEl4cfbhm66XBLN$k3VrhIlICVojK" +
		"FGuPLOLiRUPjt7fwpRXsxY57DlVEhA#rcgku6B$0yn#rxWBsgvlStAlW#zmqjkuTjl8amHr" +
		"JPZOjhxNrYl6sIkvxIIjqzfUctxRd6dzNf$RjkPrzy3BqzgsVR#BvVjPRRFVJwpCMiyqyPr" +
		"hOcIT92#thdnuPgHu#T#r#kTVkTTM3ztZf9sjl5fsguh4dIRq1Y7g$5bB1b8hkVDNwjuKUO" +
		"EjvnYzq$2EalKEO9wybBdNSwbs6gK$xwsiVqSPlY6Ja5Ty$2PCWfvwdJUxonYr8mKxuXXT7" +
		"#HrEY5z1pPwwdbd9FF$bRCqgvtO$uuykse7VR7VsACUDD5NCnsXcNfpQWBJTU8#chhQkcvu" +
		"MATqvrrsGjOuc9swsFIHzpqrXiFfV#D5xQPsSSqJiODwmgfrhwtR3IdCMtzDMBvvZjD9qpV" +
		"LzCLIdqJqUn7gVzPqiaygnWl2FwRl5ewZxjc4e2x5HotkL8hqSSokmUckM#Gz7UMjHQ5tmA" +
		"AAbqvB7IDtiacBvKQovMlvlVYov5xmhuXOCiOiYQzGcgVYANt4cBq2NdC7dFQTqDywOoGJ#" +
		"VIiIV5Lia2ojUqprTfPmFOAMha2QvitLDEkKAB#MplqNskarBEku0IRx#s2m7yx1NCXcCU1" +
		"hOJsqDgfxrqs2MGcz1dZOleScKlOAK9RvNdR9stKzUYPPmEsXvPdhHtsYZtSMh6pHayijaV" +
		"Tz3vD3zZRzf7Xzdu12nIRsPsuaWoNuJgRhKVip9#rV#HSIUBpYAad69lcs2#AWtwQkr3Msf" +
		"pjkMWdxOpM9BWZ5xi2uRWuM4d8CahU66ud$OoM#vtYwg7WEo91NtBTROh#TYBFdR5W7ClXV" +
		"pcexVs4xR#OlI3jJQniVrsSxQzQch2y8Bdlm#qPcSzVEKtLZ6l3EfAysFOGorzf$ncZhzOd" +
		"vBPZP9OljknmKQxQtBn$NstkS#RQtRVDSQSbyPmPq#g#Y8zPTr72aT7dc#71EIywBddFp3B" +
		"7wINTVyNDqRwG$oRq9JOhJ3cdYTwUSmsCdRNDobgPKxyPaLmpCgefpyXAj9YuQeJtoHP7Ul" +
		"1NQ9fudp1fBQ#CfW57HskULsgLo3MxikvjBSwlZTfhD8T#fpJ$#ftjqU5zqkHyq4RJMF#Rn" +
		"i$TuMZOUVr#V9XNU#HoQPsOugT5kYgpFTfuk3vtXtcptzuaS#wtnaeoTQz4U2MDGjinpR$#" +
		"zyjpUI6jdiBy#Y7tlP2errftOowAZCULIJJPOvQ7ejBQI$NVgTRIEbQFBehCwolNpkBHvsJ" +
		"PFT5jL7eMLpOVpjBeh4wRnPN9wrbfzgkiVMbjypgTa7QUYAoeyQzIMB$AiKRPBkqOvudqPL" +
		"M0PV##9ukF#cxjy3T7dywOEuaSfywDE9LO5V7dd3B#RAtuuM#Hd3G7issUC3g9y$9$I8RCy" +
		"MVHYuAI8mNzTImGmYb6UhaGtXD8Vn1YvXGXvjmfHFiNXPZwaX1xloR4m4U5g7Kh6COBCQY$" +
		"K7zxeVvTrFqXnExbGjIjWr0NPPyYROZq6vI3PgyovFT6kZNoPmdHVLlWkwFi0AIJKFQS40C" +
		"EHflF8Bq1wIj8FnTYsyK8Tq4$oEg#Bt3eLc#o4CqR2z6ZFLBmE9iXG7wBbaBKVag8#Ys4g5" +
		"E4icL8Iv5#AKIpSn5#4Q8b#j3iFqACs01qTmjHzAmG6qn47lGZkaENUP3J6RBH$nvdWtuDs" +
		"hqME6omrrLe3trjTOSGszL7s0dXK9I1PaDSdMzt4mBQgZCOCav46VhIe3N24U1z2EM#49ER" +
		"WNuN8Lh3LgtQelm58QPT84GRuDt1snFZiDS7QFT9u6E463O8TCs1duen#09q3q1dwDOQUfT" +
		"3LfUXuDyKwNAa6I6sWawJzW3jz#2R0pxOeot6TrfNvD#0BOw5RWZJTWRDxwW3RIzNY8O7GU" +
		"PRmBSJOYZQx8MzOwjxG5SXH2FiYBCTyCD#lM23Dj1nJunZ7RXFeqimzh1TeGVQfIW7R#7BG" +
		"ZJU4FapaK9kO$Ib2SQaoLo4#uNOk11XAW9ygIdyfUas22iGu1URz4Au404stVH38JP3Evl1" +
		"LwTTAaI7JP3UXl5hWu1nchqLnkmY8SR1Nvh3dofkXCwmHREFqCUhuQOx2Z41iYQWpMaOlpr" +
		"FXrqn3jE#HXzXbpqnNkFtX5pOPIpirXc#DNu$zF5rf2VZGX$#Dlvw#EBRmC4xvXRO0EsDUH" +
		"NX9$0qGO3ku#6xOWHqM89wZE64Dz4#vaEBms7JwGYmotJuIqluGXkCPQkdqSPtu4CVn$O3F" +
		"Mmr0MsFm5XCceRnHTb0w3#X0tXlHy2PfGtcsqJ8QFCWvCBkHGs0lm#P68kMcmE7FOgQWXRz" +
		"QlDluB1DIyoDCPWZHQS8CN9Zs6iqnXjzgZCA#2oa69FfVL6FEJ4MFbe4$nmBEsy5UKKx8C3" +
		"NfsCkxFaPv62#JJeC#PdWWotRmYv5w5jTp9bYp6FiIg8OytN4WKYfNvYpO#7R0dD1mCvZFq" +
		"60NYKZ8GD#q07sd8xnBkc1W34eGT$BCMwji1QKmESwmzV6mU#wOUoAVWME#Jsk9mBgMdT2#" +
		"$2R4V3vST1X1EP49up3QCm91tDd2kPdRTYf16DO0Z#U1BhfwEj4h0Kbi6K9ncFEnqYFGzrv" +
		"A4SVvi0dIk2lap1#4s7hOLYpvWv0sIgKGU#9Ou5VZFcBkJGH#a$4kRGjVBCjrheHy8SHc4j" +
		"5to8F6#$H2lR6kh07$A$t4F1XBTi3uxe7skq8$#u5kxGv0UiRx3mTlYsmdWt5$6np7MZVGR" +
		"WNvV3bOHXlTpVaCGzA7aOPrkRXc5kRKXdQd4xZ0fyQ2pyPZtat$MUay6yNFjy1yxy4FbY2E" +
		"JqTuzeTPStWDoKu8vUWZpDgOyszJuZCHiZ3rZEWrtZORWRwdcb4hnUZB$KGqEyzhe4lFG8S" +
		"zifWZVMWxmpuLW7Mh8denwOOnmnqoA3VHLkY3FDn8lnm1coNWVzbuD#zCMVRVeM0SPWDssH" +
		"0DmDzp60Td06TCrWJ#c0SAj363FInBNno1iQe3yPt1lJh39$Be3w3UPuX7Q5l1hwLsHu1Qs" +
		"1thAaPs7lO8T0NOp#Pz8O$JSGS6OJrRIBiCH9hL0PswWDTHwBT5l0B0PksmFpUP1$OPo1Iy" +
		"DR5Nj46wq1Tx5rzi0PduBFrC1$gOGtk2BwHc9yji1RtmNYsX2#MOnn6mYTQBaIATQmRPBPy" +
		"7kiWze$9qD657ut1kfJ1NkTY$Ho9Va#UZHJzd0pxZSIuJOPVJeRD9aFMAD1EWLyDHBjJuBC" +
		"3OPCfksADHzkP1GXOLqPXtdG4FWhzx8vzUmhMqowOWrsmhcm5dRfW7cQmJso5FRSj$7Shq1" +
		"HZ3MYBEPh1VDiAjjqQuzSSVSzWZHw5#RydskcCzQqOQqe6$5l32RO#1sNmdmwexmsRj8Ny3" +
		"CPaQwoHss2zsMOOsdeSzLXFFFYhX$QsWGtQO2$Q1ljVL$XGL#ZUzMW4p5CFVIo0JnHWRow0" +
		"7zQ2RMh19hN1cm7VAEo5Us8ztXPzxFfVs1BxqKp8o61kTeEUtR06rqORRJ2MVJ3FMs7l6G1" +
		"$68AvtWhwjO8l3S4UqHfhSn$OCeCnsXxxHclCv#t9Ht2Uw8nq5CQvDVQVxh1D6yo5xJ4s6U" +
		"pPmz3VKV2RDbWZsro1W7czFUPz4VJS7ZvOXFeTi1SMORtO0MjZszv8SNveUn9IXBRl8SNyB" +
		"KRT3g0fnZgn8to#6BmxqdfIWXG#MeBsTeJy4lZvZglHDdJS2NfaPY35Mf11ttQ2pgNe#quh" +
		"aS8FTqBVIh4lx0HVBiKPfY$wNWP$tXHhStEiundCvteOr$hT48v7m3wqGKUCpMK8iEy6yCy" +
		"DiFPaC9Stn1ZF17ypx4Kp8QC8yeknTis4pnN3FufXYw4umsq8FNj1PWPx#8QFuIo3irO3s7" +
		"zJwDOSQ$Wmz3K3tsg0iy96M4jQexrYZ4SnnZ#3SMtL1odws1Vhu538wGiTCj2jByvKPUSZX" +
		"V#LOTtS6UUn3ER2pXZl3CetntnhYlKrWpxi3DygXkrsXWzai3$j37$Be4#ROr$hG7mqpYG3" +
		"wyGex5cxOCuCmzbkSwoRks1VteBam3zsWGzkWVLsEDQ3vk3f3HyfnfpEm0OROT$P2FlKjj1" +
		"xMzXcECwRBJ37UkDSK4np2VEz8TR#Xh1FR#mPGx0Uby8MMs0TReUzQH3Ml24eRm4Vtnrj3e" +
		"KzIp6$HgAk8$oo8#opAVnoEFob67j1GunzAunjS$X91cjqGwpLZR2F5a7NKlZ2Bj2b0lMDO" +
		"8lc68z6c7UxO7tU5Mjp8NGgXCqBuPkDiMQLuXouAzR12gofms6dnj2Z57RS37laPXZJKep1" +
		"PbXVXcFDRWmxROQsXiAFAz2leVEnLc6TgC1QFHnpVpJMY6BuSIlqjG9pTHREAyMObyNGlHF" +
		"aTS9y7m4zIz6FJcYd4zQJqV2tCPZFe#7xis2xKkpJ4x3Ujy8O5MEjdu9vMmgVs19zsnBZlo" +
		"LygHpjJC8u384lxugpooICnMZeMe5pLJFOkXJN6CLOkqjXgq6OVxjIdx3kjC9ycWNVACRO3" +
		"iAQD0YoMi6$HgETOlIh5Buo27sSV1heiDyLOtuFnZer63eDnhxL0ZvI2fyknTbuCDQxmV33" +
		"qLZl1sCj7Wnx3e7UtM3h8LWZMa7l2V3nIMYh6FvK2dkLOlndmN$tmZnjW$bGYZsa56l$BBI" +
		"t5zRZKlXa6ypxNR7sxGNUKlZRhj1XB#Yu5zRCQPWlit1EcOxpsMvO1wTZ7sYFjekH7uAvC1" +
		"rhuYpgF#RyRXZt6PZNkw6zqV2V8Q0T3NllJJR6#Es6i#4CwDY4pXbODtjZJTWDSxOV#biAU" +
		"$N36Ry2VIh6V2#5Z2AiVQrmlYZ2UQGjvaWfreiMs0jBSMxj1pze1rdjVuJziCzs04qRs6XF" +
		"p8sniDiOh77buq2ByzWus7qSVAIu2yvDjBP1$tASz#OWNuBvCmSwby3$Ic3pZiEXByQa5Bg" +
		"MOexKnNgy5Mmq1RvHYh4RXxDT8MpN0VPgYdsh579AiHwsnVhS1hxS5FEp3tGgfZc4STeJia" +
		"l9Bp0cfPY3syCM9T2l5FGTCVV7mGxb6ACYhB7RuunAbxZZqFzncAVZO9lnM2zAoKzWw#r1N" +
		"m9$QWDRJi4P7bDLJ84Fbs4Tcm8VA4NO0JOl1bqvT9Y4lat5sb#2UL26#R43zlUfM7lBuBjJ" +
		"iQvtWgscmdO5cATJSKOemJfGXZLYAFnyAiQo5QwXfsBjd8evK8QvtHhNZ5FX7qCfXQ$KmXb" +
		"jAlnnAiQbC#PzNR8bP9JGlWIVtnDjJyBUq0$pj1JZsWG#qWJdwdwuHY$7NhqnsXwESTyODc" +
		"w3lMBZj#WZL1XNd4Vwu#nGXdQQGav$qBR7cj4VSijmxcgADRK$$AizTEkFCzfmy6w2$M80v" +
		"dvx#7q9$6iyT6c6FQmvNNEXpRbOJ#Q2fnJhQ6USLyhWQsNOv#V21cKuytJ6N9YBjRiCPxEv" +
		"yESodDld$eOK$Pb7ziEQCm$hN1dEBMNOIygcgtiHe#zKQOkBLUezHAd22t3ExFIhoQkoscT" +
		"6yyq#iVEghBchqn4w$KsbhLuAQLhNrcb9MDP#l4fRla#fbF8zbQzBOL#j9yxVzSQ4FFLEZx" +
		"TVcO2z#hpiijrFKwdegz92#Eu6kcxBdLIwmL5HdZetH$CROW$Q#9veMUyLqNo3kLhcYIfj2" +
		"jziSBAsmQKXNOUn8LxUECIT3RGSd3yxRQ9blQxIZN2s6DWsrg$FLLhhMqs3ELjnJbXF#r73" +
		"VUFs2Ej7xXtY3V#RJbTOAwtkpmRieNIFw4g5DskdqkOlghJz19LswXZIDyVPfyLZ2c#wB2p" +
		"lyO5Ak$#g#uu9snBxd1YbPMTq#MALTfoRNxVQj4#E3FCRVwZIrlLKkiU1oNoz#aVpWnfgUQ" +
		"#gj0NspTOBepJD9ePuaJLtsgJgYRfFBVn7hTjdEhrRoz9#r0hxR2kSBugmrcxNZFQjt7ql7" +
		"gJJAGbrs2TQxMpbxz8wR9kWur8Br$EY3TQpaWRPj2NrelcYuIgjw#bstWthkY$Dvcz#kKgt" +
		"tLEbBSxL#LD2cfPzTDcJOLaFHwL3dz0qNyHbg$AcCxLUEF#MZBFwZ#lRrireNL7v4TXVYwR" +
		"gFj4UhjU5xIfqsJ2wdwBB8lr0$i5OctfkbupKwNALZYxNUUn19IiKFkO0NNQfpg$KCdzFxa" +
		"$RcopyLfssqJ8E3UislYIPlysxcdQMjilxEZyxf2dg4E8bD#WohVlu3vBaMZfjf$bm$JEfc" +
		"S9dRgdIlRw9qexuCiJts4YbpN6sxd2d9K$lMtlG#UgBiBm4#$GalKwC$eykm$NTp3yKFXTd" +
		"gP9759vfOF6z4#9pxzUffflxTbI$kNfzclkfJdsLplaaf9cd$NnUtJIRXBGjotHA$eKpJAP" +
		"MMDVs12sdIANTw5uTphIPEbPRfIeTtbpTfyeKvMkpgW5jjLTffZWiwuano6IoQQTg$#wCyt" +
		"Jt5c7v0EtBq$TIwOnBTAhNkGpE3tE#qdYXhdjPsmFddJdVHTinUwspZqwVLwchVTFLSyhLy" +
		"yyRejFhLLgWr$G2pL#W#Mjf$bgQt#pDjJM$shF2UTtxO9KErMl3bBOgRVwHxajmLeZgNu7h" +
		"ZBOlPPTtcgpIdhEiicj2lCNMAgLx5fcAA6#BOtJRkCRF38$MDSErHsQ0mjk#hTBPMjUP$NI" +
		"#aqvxw78zfsPE3#LazjPbTFyDP$wPkisPAqEQ4O#5#EnTT5fXbOstSBtsjD1xwuIRr7sup7" +
		"ABPe5ApPoPYND$1cju9jWNTB#UHzagIzUTO8ij4JeI7gLjZ$DwnpUqNBJNjhdM0zVWcRFfl" +
		"eebvnQjnr5MsPsslAG0UhrVjjJxKcQonQ$F#QsQXMNbsXVBSLtS$0LD1rrcdwLfhrBfo9rr" +
		"VtS8UOjRqFsbC3zlfn3lUM68jy8rU0RNBprw88siSL7TPzuRpMTkH1kzwTwaHRF6QkED63s" +
		"kE#VMjyT3bVSgp6uhW#kouddHilQnVNIk7ljcJqNBI$NroW0zFpEuvYnjeV21psaQdFqpsE" +
		"DdRHtopLeIbTD1p#TP#ioH#HbyEDiEU5hbnpVIzNgVcFMMIlVMOp9Uhnkple$tBzhExFErJ" +
		"cLM7sBpkBI1bhsnIekr3iNFe6wNAErux0kbkqNBskYrSTB5mCVficij#RWMttrRZMk$B#zg" +
		"rMTKsZPOxwqwlNyN7Q5roZfheUwv42ynQKjrlwbjQxf$5ES9wLMRe1cevH#gyuCj6ZrFIhQ" +
		"pzDBhTTlvEg$7fVKLMiurkdo6IWVgwzRMkwkqntuwVvwkrsUmujfMNxIF5NNJih26pzRNq7" +
		"lJ$ShhGzhP$mtnKdrkAj7hwXpjItjZVIhLvxOvBNNPMBf7fCkqhUTO$PopgvQ9TR9ri8x60" +
		"zRHJKEyXTPxuZl0lrTuIxqVjrgj#xs5Jf$IylKvX$wSt$XhMhyBDmW$8VyJqf#H$eBKX8UH" +
		"VnZfhqX$HNeQqjE4PmMNmwaeFnLv5UeY5EXGImTLzn3e7WBz#L3ZVE3deqm5b$DBW2y1$HB" +
		"a5LwWKxlSrBdYLWu52BN59#3$1EMFWEuuuCS1Lw6kXNlYKRJzAFWU1VuOXre8hiRjOChTeF" +
		"vnf8#ZhSyW$pFadq3ud8CZdeGUzwB#NfrYXKNmn5CSN74kQCxbb48jSG7eBa3P1QXNePOEA" +
		"lyCw9v5#YpAi8E8TpaK87Wwk3ge$7l0tmFD5w2dy2LelqJw7FIby1NoNuaw2BN5IhIxajC2" +
		"X5e8dZWH#8aeFv5nJtmDUMkGhe7CRpXuEhWwUE9RyAhWYU#GteRqUmwEU1xv5u2$0Fnsu8k" +
		"HqlVJ5wDiEVBBWOTfWKvT$WzLl#c0dGt15Iy2Vn5yro3zWOCd3aHw8EeEX8m3qPS3kSpJUG" +
		"e55eshQGfqNJrDMzVY#pF1w5772fxLjg9R07sYmRE2gzC2dTPA2Pv5Lw3vR3oUzyJJQEjfu" +
		"DSYfN0TS3kyXR8hENZY8kGlGleAygyWlGbv2ZTpA10le$nbu5TnA107WOR2Zy1$HDdzmE#7" +
		"dkyZVH$fVQ2$3$XbgBiCD2fLuMZK7OqwbRewKBukfqUYF0nstaKeI0YctDEX5eTZW5Du0Bm" +
		"F8Fs0Gorn0$8tWETLfA#Yx0xmtetqRlZTXnnS7Jo40eJQEjJbiaj1SobuBmN#BuJJaJyTUG" +
		"glSV34vKWlHtenvDo9#ZkHteEoUr1s5sH#2lnJuAiXTpNoxo3$3cZEuE29Kv0$1Ub2f0jHV" +
		"mJI8q1x1EEr43nn6CeEGteeU0u5hWBX1GYctDFvsXPUIwTkK7SrUAz6$Pb8APo5yhEGViH1" +
		"Y8#HVepwMpW8yI3o3uB$SAI7e#myfESXVHtfwqZVvE0YEE8DuFiZtIz7E8g3cnMEHJc5VJX" +
		"uudgKNG$ThaT#rLyKBk7WwbI50pXuOb#a#w9E1OV32WwUE0Jf8KZd8fsBT3xI#PmMYEE17m" +
		"$y1AGd85s6T1dIao3d94wZOHxAhu1Thm3TspfSYFo5I77rWE08N14YEE8SfESWNOfqATA3T" +
		"LZqV#m5vzS=");

	static final Action RETURN2 = new Action() {
		public Symbol reduce(Symbol[] _symbols, int offset) {
			return _symbols[offset + 2];
		}
	};

	public ErrorReporting errorReporting; 
	
	
	/** This list of definitions is used as a backup in case the parsing cannot build the AST up to
		the root node (typically, when the user is changing code). In this case, we use this
		tree instead of the root returned by the parser to build the outline. <p> 
		We must take care not to add the children of elements which are also in this list. So,
		we use the "bTop" boolean to know if this definition should be added to the outline */
	public ArrayList<Def> recoverDefs = new ArrayList<Def>();
	
	/** backup a node, so as to be able to later recover from a parsing error */
	private void backup(Def def){
		recoverDefs.add(def);
		for(Def child: def.children)
			//child.bTop = false;
			unsetTop(child);
	}
	
	private void unsetTop(Def def){
		def.bTop = false;
		for(Def child: def.children)
			unsetTop(child);
	}
	
	/** Can this variable name be a parameter? (that is, it starts with a lowercase letter) */
	public boolean isParameter(String name) {
		return name.length() > 0 && Character.isLowerCase(name.charAt(0));
	}

	private final Action[] actions;

	public OcamlParser() {
		super(PARSING_TABLES);
		actions = new Action[] {
			Action.RETURN,	// [0] $goal = implementation
			RETURN2,	// [1] $goal = $interfaces interfaces; returns 'interfaces' although none is marked
			RETURN2,	// [2] $goal = $toplevel_phrase toplevel_phrase; returns 'toplevel_phrase' although none is marked
			RETURN2,	// [3] $goal = $use_file use_file; returns 'use_file' although none is marked
			new Action() {	// [4] implementation = structure.s
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					 
    	Def root = new Def("root", Def.Type.Root, 0, 0);
    	root.add(s);
    	root.collapse();
    	return root;
				}
			},
			new Action() {	// [5] implementation = structure.s error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					 
    	Def root = new Def("root", Def.Type.Root, 0, 0);
    	root.add(s);
    	root.collapse();
    	return root;
				}
			},
			new Action() {	// [6] interfaces = signature.s
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					 
    	Def root = new Def("root", Def.Type.Root, 0, 0);
    	root.add(s);
    	root.collapse();
    	return root;
				}
			},
			new Action() {	// [7] toplevel_phrase = top_structure.t SEMISEMI
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol t = _symbols[offset + 1];
					 return t;
				}
			},
			new Action() {	// [8] toplevel_phrase = seq_expr.s SEMISEMI
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					 return s;
				}
			},
			new Action() {	// [9] toplevel_phrase = toplevel_directive.d SEMISEMI
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol d = _symbols[offset + 1];
					 return d;
				}
			},
			new Action() {	// [10] top_structure = structure_item.i
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol i = _symbols[offset + 1];
					 return i;
				}
			},
			new Action() {	// [11] top_structure = structure_item.a top_structure.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [12] use_file = use_file_tail.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [13] use_file = seq_expr.a use_file_tail.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [14] use_file_tail = SEMISEMI
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [15] use_file_tail = SEMISEMI seq_expr.a use_file_tail.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [16] use_file_tail = SEMISEMI structure_item.a use_file_tail.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [17] use_file_tail = SEMISEMI toplevel_directive.a use_file_tail.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [18] use_file_tail = structure_item.a use_file_tail.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [19] use_file_tail = toplevel_directive.a use_file_tail.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [20] module_expr = mod_longident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [21] module_expr = STRUCT.s structure.b END
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 
    	Def def = new Def("<structure>", Def.Type.Struct, s.getStart(), s.getEnd());
    	def.add(b);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [22] module_expr = STRUCT.a structure.s error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol s = _symbols[offset + 2];
					 
    	Def def = new Def("<structure>", Def.Type.Struct, a.getStart(), a.getEnd());
    	def.add(s);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [23] module_expr = FUNCTOR LPAREN UIDENT.i COLON module_type.a RPAREN MINUSGREATER module_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol i = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 5];
					final Symbol b = _symbols[offset + 8];
					 
    	Def def = new Def("<functor>", Def.Type.Functor, i.getStart(), i.getEnd());
    	def.add(a);
    	def.add(b);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [24] module_expr = module_expr.a LPAREN module_expr.b RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [25] module_expr = module_expr LPAREN module_expr error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [26] module_expr = LPAREN module_expr.a COLON module_type.b RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [27] module_expr = LPAREN module_expr COLON module_type error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [28] module_expr = LPAREN module_expr.a RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [29] module_expr = LPAREN module_expr error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [30] structure = structure_tail.s
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					 return s;
				}
			},
			new Action() {	// [31] structure = seq_expr.a structure_tail.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [32] structure_tail = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [33] structure_tail = SEMISEMI
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [34] structure_tail = SEMISEMI seq_expr.a structure_tail.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [35] structure_tail = SEMISEMI structure_item.a structure_tail.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [36] structure_tail = structure_item.a structure_tail.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [37] structure_tail = error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [38] structure_item = LET.l rec_flag.r let_bindings.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					@SuppressWarnings("unused")
					final Symbol l = _symbols[offset + 1];
					final Symbol r = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					 
		Def da = (Def)a;
		Def rec = (Def)r;
	
  		// add the "rec" flag
  		ArrayList<Def> lets = new ArrayList<Def>();
  		da.findLets(lets);
  		for(Def let: lets)
  			let.bRec = rec.bRec;
  			
		return a;
				}
			},
			new Action() {	// [39] structure_item = EXTERNAL val_ident_colon.i core_type.a EQUAL primitive_declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol i = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					final Symbol b = _symbols[offset + 5];
					 
		Def ident = (Def)i;
    	Def def = new Def(ident.name, Def.Type.External, ident.posStart, ident.posEnd);
    	def.add(a);
    	def.add(b);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [40] structure_item = TYPE type_declarations.t
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol t = _symbols[offset + 2];
					 return t;
				}
			},
			new Action() {	// [41] structure_item = EXCEPTION UIDENT.id constructor_arguments.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					 
    	Def def = new Def((String)id.value, Def.Type.Exception, id.getStart(), id.getEnd());
    	def.add(a);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [42] structure_item = EXCEPTION UIDENT.id EQUAL constr_longident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 4];
					 
    	Def def = new Def((String)id.value, Def.Type.Exception, id.getStart(), id.getEnd());
    	def.add(a);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [43] structure_item = MODULE UIDENT.id module_binding.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					 
    	Def def = new Def((String)id.value, Def.Type.Module, id.getStart(), id.getEnd());
    	def.add(a);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [44] structure_item = MODULE REC module_rec_bindings.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 3];
					 return a;
				}
			},
			new Action() {	// [45] structure_item = MODULE TYPE ident.id EQUAL module_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 5];
					 
    	Def ident = (Def)id;
    	Def def = new Def(ident.name, Def.Type.ModuleType, ident.posStart, ident.posEnd);
    	def.add(a);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [46] structure_item = OPEN mod_longident.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 2];
					 
    	Def ident = (Def)id;
    	Def def = new Def(ident.name, Def.Type.Open, ident.posStart, ident.posEnd);
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [47] structure_item = CLASS class_declarations.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [48] structure_item = CLASS TYPE class_type_declarations.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 3];
					 return a;
				}
			},
			new Action() {	// [49] structure_item = INCLUDE module_expr.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 2];
					 
    	Def ident = (Def)id;
    	if(ident.type == Def.Type.Identifier){
    		Def def = new Def(ident.name, Def.Type.Include, ident.posStart, ident.posEnd);
    		backup(def);
	    	return def;
	    }
	    return new Def();
				}
			},
			new Action() {	// [50] module_binding = EQUAL module_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [51] module_binding = COLON module_type.a EQUAL module_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [52] module_binding = LPAREN UIDENT COLON module_type.a RPAREN module_binding.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 4];
					final Symbol b = _symbols[offset + 6];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [53] module_rec_bindings = module_rec_binding.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [54] module_rec_bindings = module_rec_bindings.a AND module_rec_binding.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 
  		Def db = (Def)b;
		db.bAnd = true;
  		return Def.root(a,b);
				}
			},
			new Action() {	// [55] module_rec_binding = UIDENT.id COLON module_type.a EQUAL module_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 3];
					final Symbol b = _symbols[offset + 5];
					 
    	Def def = new Def((String)id.value, Def.Type.Module, id.getStart(), id.getEnd());
    	def.add(a);
    	def.add(b);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [56] module_type = mty_longident.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return id;
				}
			},
			new Action() {	// [57] module_type = SIG.s signature.a END
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 2];
					 
    	Def def = new Def("<signature>", Def.Type.Sig, s.getStart(), s.getEnd());
    	def.add(a);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [58] module_type = SIG signature error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [59] module_type = FUNCTOR LPAREN UIDENT.id COLON module_type.a RPAREN MINUSGREATER module_type.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 5];
					final Symbol b = _symbols[offset + 8];
					 
    	Def def = new Def((String)id.value, Def.Type.Functor, id.getStart(), id.getEnd());
    	def.add(a);
    	def.add(b);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [60] module_type = module_type.a WITH with_constraints.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [61] module_type = LPAREN module_type.a RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [62] module_type = LPAREN module_type error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [63] signature = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [64] signature = signature.a signature_item.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [65] signature = signature.a signature_item.b SEMISEMI
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [66] signature_item = VAL.v val_ident_colon.id core_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol v = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					 
    	Def ident = (Def)id;
    	Def def = new Def(ident.name, Def.Type.Let, ident.posStart, ident.posEnd);
    	def.add(a);
    	def.collapse();
  		
  		// add the start position of the definition
  		def.defPosStart = v.getStart();
    	
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [67] signature_item = EXTERNAL.e val_ident_colon.id core_type.a EQUAL primitive_declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol e = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					final Symbol b = _symbols[offset + 5];
					 
    	Def ident = (Def)id;
    	Def def = new Def(ident.name, Def.Type.External, ident.posStart, ident.posEnd);
  		def.defPosStart = e.getStart();
    	def.add(a);
    	def.add(b);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [68] signature_item = TYPE.t type_declarations.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol t = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 2];
					 
  		Def da = (Def)a;
  		Def first = da.findFirstOfType(Def.Type.Type);
  		first.defPosStart = t.getStart();
  		
  		return a;
				}
			},
			new Action() {	// [69] signature_item = EXCEPTION.e UIDENT.id constructor_arguments.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol e = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					 
    	Def def = new Def((String)id.value, Def.Type.Exception, id.getStart(), id.getEnd());
    	def.defPosStart = e.getStart();
    	def.add(a);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [70] signature_item = MODULE.m UIDENT.id module_declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					 
    	Def def = new Def((String)id.value, Def.Type.Module, id.getStart(), id.getEnd());
    	def.defPosStart = m.getStart();
    	def.add(a);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [71] signature_item = MODULE.m REC module_rec_declarations.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 3];
					 
  		Def da = (Def)a;
  		Def first = da.findFirstOfType(Def.Type.Module);
  		first.defPosStart = m.getStart();
  	
  		return a;
				}
			},
			new Action() {	// [72] signature_item = MODULE.m TYPE ident.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 3];
					 
    	Def ident = (Def)id;
    	Def def = new Def(ident.name, Def.Type.ModuleType, ident.posStart, ident.posEnd);
    	def.defPosStart = m.getStart();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [73] signature_item = MODULE.m TYPE ident.id EQUAL module_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 5];
					 
    	Def ident = (Def)id;
    	Def def = new Def(ident.name, Def.Type.ModuleType, ident.posStart, ident.posEnd);
    	def.defPosStart = m.getStart();
    	def.add(a);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [74] signature_item = OPEN.o mod_longident.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol o = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 2];
					 
    	Def ident = (Def)id;
    	Def def = new Def(ident.name, Def.Type.Open, ident.posStart, ident.posEnd);
    	def.defPosStart = o.getStart();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [75] signature_item = INCLUDE.i module_type.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol i = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 2];
					 
    	Def ident = (Def)id;
    	if(ident.type == Def.Type.Identifier){
    		Def def = new Def(ident.name, Def.Type.Include, ident.posStart, ident.posEnd);
    		def.defPosStart = i.getStart();
    		backup(def);
	    	return def;
	    }
	    return new Def();
				}
			},
			new Action() {	// [76] signature_item = CLASS.c class_descriptions.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol c = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 2];
					 
  		Def da = (Def)a;
  		Def first = da.findFirstOfType(Def.Type.Class);
  		first.defPosStart = c.getStart();
  	
  		return a;
				}
			},
			new Action() {	// [77] signature_item = CLASS.c TYPE class_type_declarations.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol c = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 3];
					 
  		Def da = (Def)a;
  		Def first = da.findFirstOfType(Def.Type.ClassType);
  		first.defPosStart = c.getStart();
  	
  		return a;
				}
			},
			new Action() {	// [78] module_declaration = COLON module_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [79] module_declaration = LPAREN UIDENT COLON module_type.a RPAREN module_declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 4];
					final Symbol b = _symbols[offset + 6];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [80] module_rec_declarations = module_rec_declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [81] module_rec_declarations = module_rec_declarations.a AND.n module_rec_declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol n = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 
  		Def db = (Def)b;
  		db.defPosStart = n.getStart();
		db.bAnd = true;
  		return Def.root(a,b);
				}
			},
			new Action() {	// [82] module_rec_declaration = UIDENT.id COLON module_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 3];
					 
    	Def def = new Def((String)id.value, Def.Type.Module, id.getStart(), id.getEnd());
    	def.add(a);
    	def.collapse();
    	backup(def);
	    return def;
				}
			},
			new Action() {	// [83] class_declarations = class_declarations.a AND class_declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 
  		Def db = (Def)b;
		db.bAnd = true;
  		return Def.root(a,b);
				}
			},
			new Action() {	// [84] class_declarations = class_declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [85] class_declaration = virtual_flag class_type_parameters.a LIDENT.id class_fun_binding.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol id = _symbols[offset + 3];
					final Symbol b = _symbols[offset + 4];
					 
    	Def def = new Def((String)id.value, Def.Type.Class, id.getStart(), id.getEnd());
    	def.add(a);
    	def.add(b);
    	def.collapse();
    	backup(def);
	    return def;
				}
			},
			new Action() {	// [86] class_fun_binding = EQUAL class_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [87] class_fun_binding = COLON class_type.a EQUAL class_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [88] class_fun_binding = labeled_simple_pattern.a class_fun_binding.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [89] class_type_parameters = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [90] class_type_parameters = LBRACKET type_parameter_list.a RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [91] class_fun_def = labeled_simple_pattern.a MINUSGREATER class_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [92] class_fun_def = labeled_simple_pattern.a class_fun_def.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [93] class_expr = class_simple_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [94] class_expr = FUN class_fun_def.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [95] class_expr = class_simple_expr.a simple_labeled_expr_list.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [96] class_expr = LET rec_flag.r let_bindings.a IN class_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol r = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					final Symbol b = _symbols[offset + 5];
					 
  		Def da = (Def)a;
  		Def rec = (Def)r;
  		
  		// transform the "lets" into "let ins" and add the "rec" flag
  		ArrayList<Def> lets = new ArrayList<Def>();
  		da.findLets(lets);
  		for(Def let: lets) {
  			let.type = Def.Type.LetIn;
  			let.bRec = rec.bRec;
  		}
  		
  		if(lets.size() > 0){
  			Def last = lets.get(lets.size() - 1);
  			Def in = new Def("<in>", Def.Type.In, 0, 0);

  			in.add(b);
  			in.collapse();
  			last.children.add(in);
  			last.collapse();
  			backup(last);
  			return a;
  		}

  		return Def.root(a,b);
				}
			},
			new Action() {	// [97] class_simple_expr = LBRACKET core_type_comma_list.a RBRACKET class_longident.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [98] class_simple_expr = class_longident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [99] class_simple_expr = OBJECT.o class_structure.a END
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol o = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 2];
					 
    	Def def = new Def("<object>", Def.Type.Object, o.getStart(), o.getEnd());
    	def.add(a);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [100] class_simple_expr = OBJECT class_structure error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [101] class_simple_expr = LPAREN class_expr.a COLON class_type.b RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [102] class_simple_expr = LPAREN class_expr COLON class_type error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [103] class_simple_expr = LPAREN class_expr.a RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [104] class_simple_expr = LPAREN class_expr error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [105] class_structure = class_self_pattern.a class_fields.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [106] class_self_pattern = LPAREN pattern.a RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [107] class_self_pattern = LPAREN pattern.a COLON core_type.b RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [108] class_self_pattern = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [109] class_fields = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [110] class_fields = class_fields.a INHERIT class_expr.b parent_binder.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					final Symbol c = _symbols[offset + 4];
					 return Def.root(a,b,c);
				}
			},
			new Action() {	// [111] class_fields = class_fields.a VAL.v virtual_value.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol v = _symbols[offset + 2];
					final Symbol id = _symbols[offset + 3];
					 
    	Def ident = (Def)id;
    	if(ident.type == Def.Type.Identifier){
    		Def def = new Def(ident.name, Def.Type.Val, ident.posStart, ident.posEnd);
    		def.defPosStart = v.getStart(); 
    		backup(def);
	    	return Def.root(a, def);
	    }
	    return Def.root(a,id);
				}
			},
			new Action() {	// [112] class_fields = class_fields.a VAL.v value.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol v = _symbols[offset + 2];
					final Symbol id = _symbols[offset + 3];
					 
    	Def ident = (Def)id;
    	if(ident.type == Def.Type.Identifier){
    		Def def = new Def(ident.name, Def.Type.Val, ident.posStart, ident.posEnd);
    		def.defPosStart = v.getStart();
    		backup(def);
	    	return Def.root(a, def);
	    }
	    return Def.root(a,id);
				}
			},
			new Action() {	// [113] class_fields = class_fields.a virtual_method.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [114] class_fields = class_fields.a concrete_method.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [115] class_fields = class_fields.a CONSTRAINT.c constrain.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol c = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 
    	Def def = new Def("<constraint>", Def.Type.Constraint, c.getStart(), c.getEnd());
    	def.add(b);
    	def.collapse();
    	backup(def);
    	return Def.root(a, def);
				}
			},
			new Action() {	// [116] class_fields = class_fields.a INITIALIZER.i seq_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol i = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 
    	Def def = new Def("initializer", Def.Type.Initializer, i.getStart(), i.getEnd());
    	def.defPosStart = i.getStart();
    	def.add(b);
    	def.collapse();
    	backup(def);
    	return Def.root(a, def);
				}
			},
			new Action() {	// [117] parent_binder = AS LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 2];
					 
    	return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [118] parent_binder = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [119] virtual_value = MUTABLE.m VIRTUAL label.id COLON core_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 5];
					 
    	Def ident = (Def)id;
    	assert (ident.type == Def.Type.Identifier);
    	Def def = new Def(ident.name, Def.Type.Val, ident.posStart, ident.posEnd);
    	def.defPosStart = m.getStart();
    	def.add(a);
    	def.collapse();
    	def.bAlt = true;
    	backup(def);
	    return def;
				}
			},
			new Action() {	// [120] virtual_value = VIRTUAL.v mutable_flag.m label.id COLON core_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol v = _symbols[offset + 1];
					final Symbol m = _symbols[offset + 2];
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 5];
					 
    	Def ident = (Def)id;
    	assert (ident.type == Def.Type.Identifier);
    	Def def = new Def(ident.name, Def.Type.Val, ident.posStart, ident.posEnd);
    	def.defPosStart = v.getStart();
    	def.add(a);
    	def.collapse();
    	def.bAlt = ((Def)m).bAlt;
    	backup(def);
	    return def;
				}
			},
			new Action() {	// [121] value = mutable_flag.m label.id EQUAL seq_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 4];
					 
    	Def ident = (Def)id;
    	assert (ident.type == Def.Type.Identifier);
    	Def def = new Def(ident.name, Def.Type.Val, ident.posStart, ident.posEnd);
    	int pos = ((Def)m).posStart;
    	def.defPosStart = (pos != 0 ? pos : ident.posStart);
    	def.add(a);
    	def.collapse();
    	def.bAlt = ((Def)m).bAlt;
    	backup(def);
	    return def;
				}
			},
			new Action() {	// [122] value = mutable_flag.m label.id type_constraint.a EQUAL seq_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					final Symbol b = _symbols[offset + 5];
					 
    	Def ident = (Def)id;
    	assert (ident.type == Def.Type.Identifier);
    	Def def = new Def(ident.name, Def.Type.Val, ident.posStart, ident.posEnd);
    	int pos = ((Def)m).posStart;
    	def.defPosStart = (pos != 0 ? pos : ident.posStart);
    	def.add(a);
    	def.add(b);
    	def.collapse();
    	def.bAlt = ((Def)m).bAlt;
    	backup(def);
	    return def;
				}
			},
			new Action() {	// [123] virtual_method = METHOD.m PRIVATE VIRTUAL label.id COLON poly_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 4];
					final Symbol a = _symbols[offset + 6];
					 
    	Def ident = (Def)id;
    	assert (ident.type == Def.Type.Identifier);
    	Def def = new Def(ident.name, Def.Type.Method, ident.posStart, ident.posEnd);
    	def.defPosStart = m.getStart();
    	def.add(a);
    	def.collapse();
    	def.bAlt = true;
    	backup(def);
	    return def;
				}
			},
			new Action() {	// [124] virtual_method = METHOD.m VIRTUAL private_flag.p label.id COLON poly_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol p = _symbols[offset + 3];
					final Symbol id = _symbols[offset + 4];
					final Symbol a = _symbols[offset + 6];
					 
    	Def ident = (Def)id;
    	assert (ident.type == Def.Type.Identifier);
    	Def def = new Def(ident.name, Def.Type.Method, ident.posStart, ident.posEnd);
    	def.defPosStart = m.getStart();
    	def.add(a);
    	def.collapse();
    	def.bAlt = ((Def)p).bAlt;
    	backup(def);
	    return def;
				}
			},
			new Action() {	// [125] concrete_method = METHOD.m private_flag.p label.id strict_binding.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol p = _symbols[offset + 2];
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 4];
					 
    	Def ident = (Def)id;
    	assert (ident.type == Def.Type.Identifier);
    	Def def = new Def(ident.name, Def.Type.Method, ident.posStart, ident.posEnd);
    	def.defPosStart = m.getStart();
    	def.add(a);
    	def.collapse();
    	def.bAlt = ((Def)p).bAlt;
    	backup(def);
	    return def;
				}
			},
			new Action() {	// [126] concrete_method = METHOD.m private_flag.p label.id COLON poly_type.a EQUAL seq_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol p = _symbols[offset + 2];
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 5];
					final Symbol b = _symbols[offset + 7];
					 
    	Def ident = (Def)id;
    	assert (ident.type == Def.Type.Identifier);
    	Def def = new Def(ident.name, Def.Type.Method, ident.posStart, ident.posEnd);
    	def.defPosStart = m.getStart();
    	def.add(a);
    	def.add(b);
    	def.collapse();
    	def.bAlt = ((Def)p).bAlt;
    	backup(def);
	    return def;
				}
			},
			new Action() {	// [127] concrete_method = METHOD.m private_flag.p LABEL.id poly_type.a EQUAL seq_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol p = _symbols[offset + 2];
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 4];
					final Symbol b = _symbols[offset + 6];
					 
    	Def def = new Def((String)id.value, Def.Type.Method, id.getStart(), id.getEnd());
    	def.defPosStart = m.getStart();
    	def.add(a);
    	def.add(b);
    	def.collapse();
    	def.bAlt = ((Def)p).bAlt;
    	backup(def);
	    return def;
				}
			},
			new Action() {	// [128] class_type = class_signature.s
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					 return s;
				}
			},
			new Action() {	// [129] class_type = QUESTION LIDENT COLON simple_core_type_or_tuple MINUSGREATER class_type.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol c = _symbols[offset + 6];
					 return c;
				}
			},
			new Action() {	// [130] class_type = OPTLABEL simple_core_type_or_tuple MINUSGREATER class_type.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol c = _symbols[offset + 4];
					 return c;
				}
			},
			new Action() {	// [131] class_type = LIDENT COLON simple_core_type_or_tuple MINUSGREATER class_type.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol c = _symbols[offset + 5];
					 return c;
				}
			},
			new Action() {	// [132] class_type = simple_core_type_or_tuple MINUSGREATER class_type.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol c = _symbols[offset + 3];
					 return c;
				}
			},
			new Action() {	// [133] class_signature = LBRACKET core_type_comma_list RBRACKET clty_longident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [134] class_signature = clty_longident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [135] class_signature = OBJECT.o class_sig_body.a END
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol o = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 2];
					 
    	Def def = new Def("<object>", Def.Type.Object, o.getStart(), o.getEnd());
    	def.add(a);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [136] class_signature = OBJECT class_sig_body error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [137] class_sig_body = class_self_type.a class_sig_fields.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [138] class_self_type = LPAREN core_type.a RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return Def.root(a);
				}
			},
			new Action() {	// [139] class_self_type = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [140] class_sig_fields = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [141] class_sig_fields = class_sig_fields.s INHERIT class_signature.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 3];
					 return Def.root(s,a);
				}
			},
			new Action() {	// [142] class_sig_fields = class_sig_fields.s VAL.v value_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					final Symbol v = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					 
  		Def da = (Def)a;
  		da.defPosStart = v.getStart();
  		return Def.root(s,a);
				}
			},
			new Action() {	// [143] class_sig_fields = class_sig_fields.s virtual_method.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 2];
					 return Def.root(s,a);
				}
			},
			new Action() {	// [144] class_sig_fields = class_sig_fields.s method_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 2];
					 return Def.root(s,a);
				}
			},
			new Action() {	// [145] class_sig_fields = class_sig_fields.s CONSTRAINT constrain.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol s = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 3];
					 return Def.root(s,a);
				}
			},
			new Action() {	// [146] value_type = VIRTUAL mutable_flag.m label.id COLON core_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 2];
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 5];
					 
    	Def ident = (Def)id;
    	assert (ident.type == Def.Type.Identifier);
    	Def def = new Def(ident.name, Def.Type.Val, ident.posStart, ident.posEnd);
	    def.add(a);
	    def.collapse();
    	def.bAlt = ((Def)m).bAlt;
	    backup(def);
	    return def;
				}
			},
			new Action() {	// [147] value_type = MUTABLE virtual_flag label.id COLON core_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 5];
					 
    	Def ident = (Def)id;
    	assert (ident.type == Def.Type.Identifier);
    	Def def = new Def(ident.name, Def.Type.Val, ident.posStart, ident.posEnd);
	    def.add(a);
	    def.collapse();
    	def.bAlt = true;
	    backup(def);
	    return def;
				}
			},
			new Action() {	// [148] value_type = label.id COLON core_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 3];
					 
    	Def ident = (Def)id;
    	assert (ident.type == Def.Type.Identifier);
    	Def def = new Def(ident.name, Def.Type.Val, ident.posStart, ident.posEnd);
	    def.add(a);
	    def.collapse();
	    backup(def);
	    return def;
				}
			},
			new Action() {	// [149] method_type = METHOD.m private_flag label.id COLON poly_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 5];
					 
    	Def ident = (Def)id;
    	assert (ident.type == Def.Type.Identifier);
    	Def def = new Def(ident.name, Def.Type.Method, ident.posStart, ident.posEnd);
    	def.defPosStart = m.getStart(); 
	    def.add(a);
	    def.collapse();
	    backup(def);
	    return def;
				}
			},
			new Action() {	// [150] constrain = core_type.a EQUAL core_type.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [151] class_descriptions = class_descriptions.a AND.n class_description.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol n = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 
  		Def db = (Def)b;
  		db.defPosStart = n.getStart();
		db.bAnd = true;
  		return Def.root(a,b);
				}
			},
			new Action() {	// [152] class_descriptions = class_description.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [153] class_description = virtual_flag class_type_parameters LIDENT.id COLON class_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 5];
					 
    	Def def = new Def((String)id.value, Def.Type.Class, id.getStart(), id.getEnd());
	    def.add(a);
	    def.collapse();
	    backup(def);
	    return def;
				}
			},
			new Action() {	// [154] class_type_declarations = class_type_declarations.a AND.n class_type_declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol n = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 
  		Def db = (Def)b;
  		db.defPosStart = n.getStart();
		db.bAnd = true;
  		return Def.root(a,b);
				}
			},
			new Action() {	// [155] class_type_declarations = class_type_declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [156] class_type_declaration = virtual_flag class_type_parameters LIDENT.id EQUAL class_signature.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 5];
					 
    	Def def = new Def((String)id.value, Def.Type.ClassType, id.getStart(), id.getEnd());
	    def.add(a);
	    def.collapse();
	    backup(def);
	    return def;
				}
			},
			new Action() {	// [157] seq_expr = expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [158] seq_expr = expr.a SEMI
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [159] seq_expr = expr.a SEMI seq_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [160] labeled_simple_pattern = QUESTION LPAREN label_let_pattern.a opt_default.b RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 3];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [161] labeled_simple_pattern = QUESTION label_var.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [162] labeled_simple_pattern = OPTLABEL.id LPAREN let_pattern.a opt_default.b RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 3];
					final Symbol b = _symbols[offset + 4];
					 
    	Def ident = new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
    	return Def.root(ident,a,b);
				}
			},
			new Action() {	// [163] labeled_simple_pattern = OPTLABEL.id pattern_var.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 2];
					 
    	Def ident = new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
    	return Def.root(ident,a);
				}
			},
			new Action() {	// [164] labeled_simple_pattern = TILDE LPAREN label_let_pattern.a RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 3];
					 return a;
				}
			},
			new Action() {	// [165] labeled_simple_pattern = TILDE label_var.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [166] labeled_simple_pattern = LABEL.id simple_pattern.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 2];
					 
    	Def ident = new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
    	return Def.root(ident,a);
				}
			},
			new Action() {	// [167] labeled_simple_pattern = simple_pattern.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [168] pattern_var = LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 
    	return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [169] pattern_var = UNDERSCORE.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 
    	return new Def("_", Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [170] opt_default = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [171] opt_default = EQUAL seq_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [172] label_let_pattern = label_var.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [173] label_let_pattern = label_var.a COLON core_type.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [174] label_var = LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 
    	return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [175] let_pattern = pattern.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [176] let_pattern = pattern.a COLON core_type.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [177] expr = simple_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [178] expr = simple_expr.a simple_labeled_expr_list.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [179] expr = LET rec_flag.r let_bindings.a IN seq_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol r = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					final Symbol b = _symbols[offset + 5];
					 
  		Def da = (Def)a;
  		Def rec = (Def)r;

  		// transform the "lets" into "let ins" and add the "rec" flag
  		ArrayList<Def> lets = new ArrayList<Def>();
  		da.findLets(lets);
  		for(Def let: lets){
  			let.type = Def.Type.LetIn;
  			let.bRec = rec.bRec;
  		}
  		
  		if(lets.size() > 0){
  			Def last = lets.get(lets.size() - 1);
  			Def in = new Def("<in>", Def.Type.In, 0, 0);
  			
  			in.add(b);
  			in.collapse();
  			last.children.add(in);
  			last.collapse();
  			backup(last);
  			return a;
  		}
	  		
  		return Def.root(a,b);
				}
			},
			new Action() {	// [180] expr = LET MODULE UIDENT.id module_binding.a IN seq_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 3];
					final Symbol a = _symbols[offset + 4];
					final Symbol b = _symbols[offset + 6];
					 
    	Def def = new Def((String)id.value, Def.Type.Module, id.getStart(), id.getEnd());
    	def.add(a);
    	def.add(b);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [181] expr = FUNCTION opt_bar.a match_cases.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [182] expr = FUN labeled_simple_pattern.a fun_def.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 
  		// find the identifiers defined in this pattern, and
  		// transform them into "parameter" nodes
  		ArrayList<Def> idents = new ArrayList<Def>();
    	Def pat = (Def)a;
    	pat.findIdents(idents);
    	
    	Def root = new Def();
    	
    	Def last = null;
    	boolean bFirst = true;
    	for(int i = 0; i < idents.size(); i++){
    		Def ident = idents.get(i);
    		if(isParameter(ident.name)) {
	    		Def def = new Def(ident.name, Def.Type.Parameter, ident.posStart, ident.posEnd);
	    		if(!bFirst)
	    			def.bAnd = true;
	    		bFirst = false;
	    		root.add(def);
	    		last = def;
    		} else {
	    		Def def = new Def(ident.name, Def.Type.Identifier, ident.posStart, ident.posEnd);
	    		root.add(def);
    		}
    	}
    	
    	if(last != null){
    		last.add(b);
    		last.collapse();
    		return root;
    	} else {
    		return Def.root(a, b);
    	}
				}
			},
			new Action() {	// [183] expr = MATCH seq_expr.a WITH opt_bar.b match_cases.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					final Symbol c = _symbols[offset + 5];
					 return Def.root(a,b,c);
				}
			},
			new Action() {	// [184] expr = TRY seq_expr.a WITH opt_bar.b match_cases.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					final Symbol c = _symbols[offset + 5];
					 return Def.root(a,b,c);
				}
			},
			new Action() {	// [185] expr = TRY seq_expr WITH error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [186] expr = expr_comma_list.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [187] expr = constr_longident.a simple_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [188] expr = name_tag.a simple_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [189] expr = IF seq_expr.a THEN expr.b ELSE expr.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					final Symbol c = _symbols[offset + 6];
					 return Def.root(a,b,c);
				}
			},
			new Action() {	// [190] expr = IF seq_expr.a THEN expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [191] expr = WHILE seq_expr.a DO seq_expr.b DONE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [192] expr = FOR val_ident.ident EQUAL seq_expr.b direction_flag seq_expr.c DO seq_expr.d DONE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol ident = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					final Symbol c = _symbols[offset + 6];
					final Symbol d = _symbols[offset + 8];
					 
	    Def i = (Def)ident;
	    Def def = new Def(i.name, Def.Type.Parameter, i.posStart, i.posEnd);
	    def.add(b);
	    def.add(c);
	    def.add(d);
	    def.collapse();
    	return def;
				}
			},
			new Action() {	// [193] expr = expr.a COLONCOLON expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [194] expr = LPAREN COLONCOLON RPAREN LPAREN expr.a COMMA expr.b RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 5];
					final Symbol b = _symbols[offset + 7];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [195] expr = expr.a INFIXOP0 expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [196] expr = expr.a INFIXOP1 expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [197] expr = expr.a INFIXOP2 expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [198] expr = expr.a INFIXOP3 expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [199] expr = expr.a INFIXOP4 expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [200] expr = expr.a PLUS expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [201] expr = expr.a MINUS expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [202] expr = expr.a MINUSDOT expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [203] expr = expr.a STAR expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [204] expr = expr.a EQUAL expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [205] expr = expr.a LESS expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [206] expr = expr.a GREATER expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [207] expr = expr.a OR expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [208] expr = expr.a BARBAR expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [209] expr = expr.a AMPERSAND expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [210] expr = expr.a AMPERAMPER expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [211] expr = expr.a COLONEQUAL expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [212] expr = subtractive expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [213] expr = simple_expr.a DOT label_longident.b LESSMINUS expr.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					final Symbol c = _symbols[offset + 5];
					 return Def.root(a,b,c);
				}
			},
			new Action() {	// [214] expr = simple_expr.a DOT LPAREN seq_expr.b RPAREN LESSMINUS expr.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 4];
					final Symbol c = _symbols[offset + 7];
					 return Def.root(a,b,c);
				}
			},
			new Action() {	// [215] expr = simple_expr.a DOT LBRACKET seq_expr.b RBRACKET LESSMINUS expr.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 4];
					final Symbol c = _symbols[offset + 7];
					 return Def.root(a,b,c);
				}
			},
			new Action() {	// [216] expr = simple_expr.a DOT LBRACE expr.b RBRACE LESSMINUS expr.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 4];
					final Symbol c = _symbols[offset + 7];
					 return Def.root(a,b,c);
				}
			},
			new Action() {	// [217] expr = label.a LESSMINUS expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [218] expr = ASSERT simple_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [219] expr = LAZY simple_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [220] expr = OBJECT.o class_structure.a END
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol o = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 2];
					 
    	Def def = new Def("<object>", Def.Type.Object, o.getStart(), o.getEnd());
    	def.add(a);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [221] expr = OBJECT class_structure error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [222] simple_expr = val_longident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [223] simple_expr = constant.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [224] simple_expr = constr_longident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [225] simple_expr = name_tag.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [226] simple_expr = LPAREN seq_expr.a RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [227] simple_expr = LPAREN seq_expr.a error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [228] simple_expr = BEGIN seq_expr.a END
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [229] simple_expr = BEGIN END
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [230] simple_expr = BEGIN seq_expr.a error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [231] simple_expr = LPAREN seq_expr.a type_constraint.b RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [232] simple_expr = simple_expr.a DOT label_longident.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [233] simple_expr = simple_expr.a DOT LPAREN seq_expr.b RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [234] simple_expr = simple_expr.a DOT LPAREN seq_expr.b error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [235] simple_expr = simple_expr.a DOT LBRACKET seq_expr.b RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [236] simple_expr = simple_expr.a DOT LBRACKET seq_expr.b error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [237] simple_expr = simple_expr.a DOT LBRACE expr.b RBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [238] simple_expr = simple_expr.a DOT LBRACE expr_comma_list.b error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [239] simple_expr = LBRACE record_expr.a RBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [240] simple_expr = LBRACE record_expr.a error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [241] simple_expr = LBRACKETBAR expr_semi_list.a opt_semi.b BARRBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [242] simple_expr = LBRACKETBAR expr_semi_list.a opt_semi.b error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [243] simple_expr = LBRACKETBAR BARRBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [244] simple_expr = LBRACKET expr_semi_list.a opt_semi.b RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [245] simple_expr = LBRACKET expr_semi_list.a opt_semi.b error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [246] simple_expr = PREFIXOP simple_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [247] simple_expr = NEW class_longident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [248] simple_expr = LBRACELESS field_expr_list.a opt_semi.b GREATERRBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [249] simple_expr = LBRACELESS field_expr_list.a opt_semi.b error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [250] simple_expr = LBRACELESS GREATERRBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [251] simple_expr = simple_expr.a SHARP label.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [252] simple_labeled_expr_list = labeled_simple_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [253] simple_labeled_expr_list = simple_labeled_expr_list.a labeled_simple_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [254] labeled_simple_expr = simple_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [255] labeled_simple_expr = label_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [256] label_expr = LABEL simple_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [257] label_expr = TILDE label_ident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [258] label_expr = QUESTION label_ident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [259] label_expr = OPTLABEL simple_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [260] label_ident = LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					
    	return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [261] let_bindings = let_binding.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol b = _symbols[offset + 1];
					 return b;
				}
			},
			new Action() {	// [262] let_bindings = let_bindings.a AND let_binding.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 
  		Def db = (Def)b;
		db.bAnd = true;
  		return Def.root(a,b);
				}
			},
			new Action() {	// [263] let_binding = val_ident.i fun_binding.f
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol i = _symbols[offset + 1];
					final Symbol f = _symbols[offset + 2];
					 
    	Def ident = (Def)i;
    	Def def = new Def(ident.name, Def.Type.Let, ident.posStart, ident.posEnd);
    	def.add(f);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [264] let_binding = pattern.p EQUAL seq_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol p = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 
  		// find the identifiers defined in this pattern, and
  		// create and return a new node for them
  		
  		ArrayList<Def> idents = new ArrayList<Def>();
    	Def pat = (Def)p;
    	
    	pat.findIdents(idents);
    	
    	Def root = new Def();
    	
    	Def last = null;
    	for(int i = 0; i < idents.size(); i++){
    		Def ident = idents.get(i);
    	
    		Def def = new Def(ident.name, Def.Type.Let, ident.posStart, ident.posEnd);
    		if(i != 0)
    			def.bAnd = true;
    			
    		root.add(def);
    		last = def;
    	}
    	
    	if(last != null){
    		last.add(b);
    		last.collapse();
    		backup(root);
    		return root;	
    	}
    	
    	return Def.root(p, b);
				}
			},
			new Action() {	// [265] fun_binding = strict_binding.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [266] fun_binding = type_constraint.a EQUAL seq_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [267] strict_binding = EQUAL seq_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [268] strict_binding = labeled_simple_pattern.p fun_binding.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol p = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 
  		ArrayList<Def> idents = new ArrayList<Def>();
    	Def pat = (Def)p;
    	
    	pat.findIdents(idents);
    	
    	Def root = new Def();
    	
    	Def last = null;
    	boolean bFirst = true;
    	for(int i = 0; i < idents.size(); i++){
    		Def ident = idents.get(i);
    		if(isParameter(ident.name)) {
	    		Def def = new Def(ident.name, Def.Type.Parameter, ident.posStart, ident.posEnd);
	    		if(!bFirst)
	    			def.bAnd = true;
	    		bFirst = false;
	    		root.add(def);
	    		last = def;
    		} else {
	    		Def def = new Def(ident.name, Def.Type.Identifier, ident.posStart, ident.posEnd);
	    		root.add(def);
    		}
    	}
    	
    	if(last != null){
    		last.add(b);
    		last.collapse();
    		backup(root);
    		return root;	
    	}
    	
    	return Def.root(p, b);
				}
			},
			new Action() {	// [269] match_cases = pattern.p match_action.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol p = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 
  		// find the identifiers defined in this pattern, and
  		// create and return a new node for them
  		
  		ArrayList<Def> idents = new ArrayList<Def>();
    	Def pat = (Def)p;
    	
    	pat.findIdents(idents);
    	
    	Def root = new Def();
    	
    	Def last = null;
    	boolean bFirst = true;
    	for(int i = 0; i < idents.size(); i++){
    		Def ident = idents.get(i);
    		if(isParameter(ident.name)) {
	    		Def def = new Def(ident.name, Def.Type.Parameter, ident.posStart, ident.posEnd);
	    		if(!bFirst)
	    			def.bAnd = true;
	    		bFirst = false;
	    		root.add(def);
	    		last = def;
    		} else {
	    		Def def = new Def(ident.name, Def.Type.Identifier, ident.posStart, ident.posEnd);
	    		root.add(def);
    		}
    	}
    	
    	if(last != null){
    		last.add(b);
    		last.collapse();
    		return root;
    	}
    	
    	return Def.root(p, b);
				}
			},
			new Action() {	// [270] match_cases = match_cases.a BAR pattern.b match_action.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					final Symbol c = _symbols[offset + 4];
					 
  		// find the identifiers defined in this pattern, and
  		// create and return a new node for them
  		
  		ArrayList<Def> idents = new ArrayList<Def>();
    	Def pat = (Def)b;
    	
    	pat.findIdents(idents);
    	
    	Def root = new Def();
    	
    	Def last = null;
    	boolean bFirst = true;
    	for(int i = 0; i < idents.size(); i++){
    		Def ident = idents.get(i);
    		if(isParameter(ident.name)) {
	    		Def def = new Def(ident.name, Def.Type.Parameter, ident.posStart, ident.posEnd);
	    		if(!bFirst)
	    			def.bAnd = true;
	    		bFirst = false;
	    		root.add(def);
	    		last = def;
    		} else {
	    		Def def = new Def(ident.name, Def.Type.Identifier, ident.posStart, ident.posEnd);
	    		root.add(def);
    		}
    	}
    	
    	if(last != null){
    		last.add(c);
    		last.collapse();
    		return Def.root(a, root);
    	}
    	
    	return Def.root(a, b, c);
				}
			},
			new Action() {	// [271] fun_def = match_action.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [272] fun_def = labeled_simple_pattern.p fun_def.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol p = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 
  		// find the identifiers defined in this pattern, and
  		// create and return a new node for them
  		
  		ArrayList<Def> idents = new ArrayList<Def>();
    	Def pat = (Def)p;
    	
    	pat.findIdents(idents);
    	
    	Def root = new Def();
    	
    	Def last = null;
    	boolean bFirst = true;
    	for(int i = 0; i < idents.size(); i++){
    		Def ident = idents.get(i);
    		if(isParameter(ident.name)) {
	    		Def def = new Def(ident.name, Def.Type.Parameter, ident.posStart, ident.posEnd);
	    		if(!bFirst)
	    			def.bAnd = true;
	    		bFirst = false;
	    		root.add(def);
	    		last = def;
    		} else {
	    		Def def = new Def(ident.name, Def.Type.Identifier, ident.posStart, ident.posEnd);
	    		root.add(def);
    		}
    	}
    	
    	if(last != null){
    		last.add(b);
    		last.collapse();
    		return root;
    	}
    	
    	return Def.root(root, b);
				}
			},
			new Action() {	// [273] match_action = MINUSGREATER seq_expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [274] match_action = WHEN seq_expr.a MINUSGREATER seq_expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [275] expr_comma_list = expr_comma_list.a COMMA expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [276] expr_comma_list = expr.a COMMA expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [277] record_expr = simple_expr.a WITH lbl_expr_list.b opt_semi.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					final Symbol c = _symbols[offset + 4];
					 return Def.root(a,b,c);
				}
			},
			new Action() {	// [278] record_expr = lbl_expr_list.a opt_semi.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [279] lbl_expr_list = label_longident.a EQUAL expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [280] lbl_expr_list = lbl_expr_list.a SEMI label_longident.b EQUAL expr.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					final Symbol c = _symbols[offset + 5];
					 return Def.root(a,b,c);
				}
			},
			new Action() {	// [281] field_expr_list = label.a EQUAL expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [282] field_expr_list = field_expr_list.a SEMI label.b EQUAL expr.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					final Symbol c = _symbols[offset + 5];
					 return Def.root(a,b,c);
				}
			},
			new Action() {	// [283] expr_semi_list = expr.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [284] expr_semi_list = expr_semi_list.a SEMI expr.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [285] type_constraint = COLON core_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [286] type_constraint = COLON core_type.a COLONGREATER core_type.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [287] type_constraint = COLONGREATER core_type.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [288] type_constraint = COLON error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [289] type_constraint = COLONGREATER error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [290] pattern = simple_pattern.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [291] pattern = pattern.a AS val_ident.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [292] pattern = pattern_comma_list.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [293] pattern = constr_longident.a pattern.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [294] pattern = name_tag.a pattern.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [295] pattern = pattern.a COLONCOLON pattern.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [296] pattern = LPAREN COLONCOLON RPAREN LPAREN pattern.a COMMA pattern.b RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 5];
					final Symbol b = _symbols[offset + 7];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [297] pattern = pattern.a BAR pattern.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [298] simple_pattern = val_ident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [299] simple_pattern = UNDERSCORE.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def("_", Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [300] simple_pattern = signed_constant.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [301] simple_pattern = CHAR DOTDOT CHAR
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [302] simple_pattern = constr_longident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [303] simple_pattern = name_tag.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [304] simple_pattern = SHARP type_longident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [305] simple_pattern = LBRACE lbl_pattern_list.a opt_semi RBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [306] simple_pattern = LBRACE lbl_pattern_list.a opt_semi error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [307] simple_pattern = LBRACKET pattern_semi_list.a opt_semi RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [308] simple_pattern = LBRACKET pattern_semi_list.a opt_semi error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [309] simple_pattern = LBRACKETBAR pattern_semi_list.a opt_semi BARRBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [310] simple_pattern = LBRACKETBAR BARRBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [311] simple_pattern = LBRACKETBAR pattern_semi_list.a opt_semi error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [312] simple_pattern = LPAREN pattern.a RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [313] simple_pattern = LPAREN pattern.a error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [314] simple_pattern = LPAREN pattern.a COLON core_type.b RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [315] simple_pattern = LPAREN pattern.a COLON core_type.b error
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 4];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [316] pattern_comma_list = pattern_comma_list.a COMMA pattern.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [317] pattern_comma_list = pattern.a COMMA pattern.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [318] pattern_semi_list = pattern.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [319] pattern_semi_list = pattern_semi_list.a SEMI pattern.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [320] lbl_pattern_list = label_longident.a EQUAL pattern.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [321] lbl_pattern_list = lbl_pattern_list.a SEMI label_longident.b EQUAL pattern.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					final Symbol c = _symbols[offset + 5];
					 return Def.root(a,b,c);
				}
			},
			new Action() {	// [322] primitive_declaration = STRING
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [323] primitive_declaration = STRING primitive_declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [324] type_declarations = type_declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [325] type_declarations = type_declarations.a AND.n type_declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol n = _symbols[offset + 2];
					final Symbol b = _symbols[offset + 3];
					 
  		Def db = (Def)b;
		db.bAnd = true;
		db.defPosStart = n.getStart();
  		return Def.root(a,b);
				}
			},
			new Action() {	// [326] type_declaration = type_parameters LIDENT.id type_kind.a constraints
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 2];
					final Symbol a = _symbols[offset + 3];
					 
    	Def def = new Def((String)id.value, Def.Type.Type, id.getStart(), id.getEnd());
    	def.add(a);
    	def.collapse();
    	backup(def);
    	return def;
				}
			},
			new Action() {	// [327] constraints = constraints CONSTRAINT constrain
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [328] constraints = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [329] type_kind = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [330] type_kind = EQUAL core_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [331] type_kind = EQUAL constructor_declarations.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [332] type_kind = EQUAL PRIVATE constructor_declarations.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 3];
					 return a;
				}
			},
			new Action() {	// [333] type_kind = EQUAL private_flag BAR constructor_declarations.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 4];
					 return a;
				}
			},
			new Action() {	// [334] type_kind = EQUAL private_flag LBRACE label_declarations.a opt_semi RBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 4];
					 return a;
				}
			},
			new Action() {	// [335] type_kind = EQUAL core_type EQUAL private_flag opt_bar constructor_declarations.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 6];
					 return a;
				}
			},
			new Action() {	// [336] type_kind = EQUAL core_type EQUAL private_flag LBRACE label_declarations.a opt_semi RBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 6];
					 return a;
				}
			},
			new Action() {	// [337] type_kind = EQUAL PRIVATE core_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [338] type_parameters = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [339] type_parameters = type_parameter
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [340] type_parameters = LPAREN type_parameter_list RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [341] type_parameter = type_variance QUOTE ident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [342] type_variance = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [343] type_variance = PLUS
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [344] type_variance = MINUS
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [345] type_parameter_list = type_parameter
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [346] type_parameter_list = type_parameter_list COMMA type_parameter
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [347] constructor_declarations = constructor_declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [348] constructor_declarations = constructor_declarations.a BAR constructor_declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [349] constructor_declaration = constr_ident.a constructor_arguments
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [350] constructor_arguments = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [351] constructor_arguments = OF core_type_list
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [352] label_declarations = label_declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [353] label_declarations = label_declarations.a SEMI label_declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 return Def.root(a,b);
				}
			},
			new Action() {	// [354] label_declaration = mutable_flag.m label.a COLON poly_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					final Symbol a = _symbols[offset + 2];
					 
		// transform the generic identifier into a type constructor 
		Def def = (Def) a;
		Def da = new Def(def.name, Def.Type.RecordTypeConstructor, def.posStart, def.posEnd);
    	int pos = ((Def)m).posStart;
    	da.defPosStart = (pos != 0 ? pos : def.posStart);
		return da;
				}
			},
			new Action() {	// [355] with_constraints = with_constraint
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [356] with_constraints = with_constraints AND with_constraint
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [357] with_constraint = TYPE type_parameters label_longident with_type_binder core_type constraints
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [358] with_constraint = MODULE mod_longident EQUAL mod_ext_longident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [359] with_type_binder = EQUAL
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [360] with_type_binder = EQUAL PRIVATE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [361] typevar_list = QUOTE ident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [362] typevar_list = typevar_list QUOTE ident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [363] poly_type = core_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [364] poly_type = typevar_list DOT core_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [365] core_type = core_type2
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [366] core_type = core_type2 AS QUOTE ident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [367] core_type2 = simple_core_type_or_tuple
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [368] core_type2 = QUESTION LIDENT COLON core_type2 MINUSGREATER core_type2
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [369] core_type2 = OPTLABEL core_type2 MINUSGREATER core_type2
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [370] core_type2 = LIDENT COLON core_type2 MINUSGREATER core_type2
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [371] core_type2 = core_type2 MINUSGREATER core_type2
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [372] simple_core_type = simple_core_type2
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [373] simple_core_type = LPAREN core_type_comma_list RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [374] simple_core_type2 = QUOTE ident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [375] simple_core_type2 = UNDERSCORE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [376] simple_core_type2 = type_longident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [377] simple_core_type2 = simple_core_type2 type_longident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [378] simple_core_type2 = LPAREN core_type_comma_list RPAREN type_longident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [379] simple_core_type2 = LESS meth_list GREATER
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [380] simple_core_type2 = LESS GREATER
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [381] simple_core_type2 = SHARP class_longident opt_present
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [382] simple_core_type2 = simple_core_type2 SHARP class_longident opt_present
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [383] simple_core_type2 = LPAREN core_type_comma_list RPAREN SHARP class_longident opt_present
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [384] simple_core_type2 = LBRACKET tag_field RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [385] simple_core_type2 = LBRACKET BAR row_field_list RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [386] simple_core_type2 = LBRACKET row_field BAR row_field_list RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [387] simple_core_type2 = LBRACKETGREATER opt_bar row_field_list RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [388] simple_core_type2 = LBRACKETGREATER RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [389] simple_core_type2 = LBRACKETLESS opt_bar row_field_list RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [390] simple_core_type2 = LBRACKETLESS opt_bar row_field_list GREATER name_tag_list RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [391] row_field_list = row_field
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [392] row_field_list = row_field_list BAR row_field
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [393] row_field = tag_field
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [394] row_field = simple_core_type2
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [395] tag_field = name_tag OF opt_ampersand amper_type_list
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [396] tag_field = name_tag
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [397] opt_ampersand = AMPERSAND
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [398] opt_ampersand = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [399] amper_type_list = core_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [400] amper_type_list = amper_type_list AMPERSAND core_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [401] opt_present = LBRACKETGREATER name_tag_list RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [402] opt_present = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [403] name_tag_list = name_tag
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [404] name_tag_list = name_tag_list name_tag
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [405] simple_core_type_or_tuple = simple_core_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [406] simple_core_type_or_tuple = simple_core_type STAR core_type_list
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [407] core_type_comma_list = core_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [408] core_type_comma_list = core_type_comma_list COMMA core_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [409] core_type_list = simple_core_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [410] core_type_list = core_type_list STAR simple_core_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [411] meth_list = field SEMI meth_list
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [412] meth_list = field opt_semi
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [413] meth_list = DOTDOT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [414] field = label COLON poly_type
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [415] label = LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [416] constant = INT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [417] constant = CHAR
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [418] constant = STRING
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [419] constant = FLOAT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [420] constant = INT32
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [421] constant = INT64
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [422] constant = NATIVEINT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [423] signed_constant = constant
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [424] signed_constant = MINUS INT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [425] signed_constant = MINUS FLOAT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [426] signed_constant = MINUS INT32
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [427] signed_constant = MINUS INT64
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [428] signed_constant = MINUS NATIVEINT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [429] ident = UIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [430] ident = LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [431] val_ident = LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [432] val_ident = LPAREN operator.o RPAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol o = _symbols[offset + 2];
					 
    	Def op = (Def)o;
    	return new Def(op.name, Def.Type.Identifier, op.posStart, op.posEnd);
				}
			},
			new Action() {	// [433] val_ident_colon = LIDENT.id COLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [434] val_ident_colon = LPAREN operator.o RPAREN COLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol o = _symbols[offset + 2];
					 
    	Def op = (Def)o;
    	return new Def(op.name, Def.Type.Identifier, op.posStart, op.posEnd);
				}
			},
			new Action() {	// [435] val_ident_colon = LABEL.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [436] operator = PREFIXOP.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [437] operator = INFIXOP0.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [438] operator = INFIXOP1.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [439] operator = INFIXOP2.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [440] operator = INFIXOP3.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [441] operator = INFIXOP4.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [442] operator = PLUS.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [443] operator = MINUS.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [444] operator = MINUSDOT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [445] operator = STAR.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [446] operator = EQUAL.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [447] operator = LESS.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [448] operator = GREATER.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [449] operator = OR.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [450] operator = BARBAR.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [451] operator = AMPERSAND.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [452] operator = AMPERAMPER.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [453] operator = COLONEQUAL.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [454] constr_ident = UIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 
    	Def def = new Def((String)id.value, Def.Type.TypeConstructor, id.getStart(), id.getEnd());
    	def.defPosStart = id.getStart(); 
    	return def;
				}
			},
			new Action() {	// [455] constr_ident = LPAREN.a RPAREN.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return new Def("()", Def.Type.TypeConstructor, a.getStart(), b.getEnd());
				}
			},
			new Action() {	// [456] constr_ident = COLONCOLON.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return new Def("::", Def.Type.TypeConstructor, a.getStart(), a.getEnd());
				}
			},
			new Action() {	// [457] constr_ident = FALSE.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def("false", Def.Type.TypeConstructor, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [458] constr_ident = TRUE.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def("true", Def.Type.TypeConstructor, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [459] val_longident = val_ident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [460] val_longident = mod_longident.a DOT val_ident.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 
  		Def da = (Def)a;
  		Def db = (Def)b;
  		return new Def(da.name + "." + db.name, Def.Type.Identifier, da.posStart, db.posEnd);
				}
			},
			new Action() {	// [461] constr_longident = mod_longident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [462] constr_longident = LBRACKET RBRACKET
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [463] constr_longident = LPAREN.a RPAREN.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 2];
					 return new Def("()", Def.Type.Identifier, a.getStart(), b.getEnd());
				}
			},
			new Action() {	// [464] constr_longident = FALSE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [465] constr_longident = TRUE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [466] label_longident = LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [467] label_longident = mod_longident.a DOT LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 3];
					 
  		Def da = (Def)a;
  		return new Def(da.name + "." + (String)id.value, Def.Type.Identifier, da.posStart, id.getEnd());
				}
			},
			new Action() {	// [468] type_longident = LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [469] type_longident = mod_ext_longident.a DOT LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 3];
					 
  		Def da = (Def)a;
  		return new Def(da.name + "." + (String)id.value, Def.Type.Identifier, da.posStart, id.getEnd());
				}
			},
			new Action() {	// [470] mod_longident = UIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [471] mod_longident = mod_longident.a DOT UIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 3];
					 
  		Def da = (Def)a;
  		return new Def(da.name + "." + (String)id.value, Def.Type.Identifier, da.posStart, id.getEnd());
				}
			},
			new Action() {	// [472] mod_ext_longident = UIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [473] mod_ext_longident = mod_ext_longident.a DOT UIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 3];
					 
  		Def da = (Def)a;
  		return new Def(da.name + "." + (String)id.value, Def.Type.Identifier, da.posStart, id.getEnd());
				}
			},
			new Action() {	// [474] mod_ext_longident = mod_ext_longident.a LPAREN mod_ext_longident.b RPAREN.par
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					final Symbol par = _symbols[offset + 4];
					 
  		Def da = (Def)a;
  		Def db = (Def)b;
  		return new Def(da.name + "(" + db.name + ")", Def.Type.Identifier, da.posStart, par.getEnd());
				}
			},
			new Action() {	// [475] mty_longident = ident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 return a;
				}
			},
			new Action() {	// [476] mty_longident = mod_ext_longident.a DOT ident.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol b = _symbols[offset + 3];
					 
  		Def da = (Def)a;
  		Def db = (Def)b;
  		return new Def(da.name + "." + db.name, Def.Type.Identifier, da.posStart, db.posEnd);
				}
			},
			new Action() {	// [477] clty_longident = LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [478] clty_longident = mod_ext_longident.a DOT LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 3];
					 
  		Def da = (Def)a;
  		return new Def(da.name + "." + (String)id.value, Def.Type.Identifier, da.posStart, id.getEnd());
				}
			},
			new Action() {	// [479] class_longident = LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol id = _symbols[offset + 1];
					 return new Def((String)id.value, Def.Type.Identifier, id.getStart(), id.getEnd());
				}
			},
			new Action() {	// [480] class_longident = mod_longident.a DOT LIDENT.id
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					final Symbol id = _symbols[offset + 3];
					 
  		Def da = (Def)a;
  		return new Def(da.name + "." + (String)id.value, Def.Type.Identifier, da.posStart, id.getEnd());
				}
			},
			new Action() {	// [481] toplevel_directive = SHARP ident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [482] toplevel_directive = SHARP ident STRING
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [483] toplevel_directive = SHARP ident INT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [484] toplevel_directive = SHARP ident val_longident
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [485] toplevel_directive = SHARP ident FALSE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [486] toplevel_directive = SHARP ident TRUE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [487] name_tag = BACKQUOTE ident.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 return a;
				}
			},
			new Action() {	// [488] rec_flag = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [489] rec_flag = REC
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 Def def = new Def(); def.bRec = true; return def;
				}
			},
			new Action() {	// [490] direction_flag = TO
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [491] direction_flag = DOWNTO
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [492] private_flag = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [493] private_flag = PRIVATE.p
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol p = _symbols[offset + 1];
					 Def def = new Def(); def.bAlt=true; def.posStart = p.getStart(); return def;
				}
			},
			new Action() {	// [494] mutable_flag = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [495] mutable_flag = MUTABLE.m
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol m = _symbols[offset + 1];
					 Def def = new Def(); def.bAlt=true; def.posStart = m.getStart(); return def;
				}
			},
			new Action() {	// [496] virtual_flag = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [497] virtual_flag = VIRTUAL.v
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol v = _symbols[offset + 1];
					 Def def = new Def(); def.bAlt=true; def.posStart = v.getStart(); return def;
				}
			},
			new Action() {	// [498] opt_bar = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [499] opt_bar = BAR
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [500] opt_semi = 
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [501] opt_semi = SEMI
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [502] subtractive = MINUS
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			},
			new Action() {	// [503] subtractive = MINUSDOT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Def();
				}
			}
		};


	// override the default error reporting: do not print errors on stderr
	this.report = errorReporting = new ErrorReporting();
	}

	protected Symbol invokeReduceAction(int rule_num, int offset) {
		return actions[rule_num].reduce(_symbols, offset);
	}
}
